<div align="center">

# DispatchDoctor 🩺

*The doctor's orders: no type instability allowed!*

[![Dev](https://img.shields.io/badge/docs-dev-blue.svg)](https://ai.damtp.cam.ac.uk/dispatchdoctor/dev/)
[![Build Status](https://github.com/MilesCranmer/DispatchDoctor.jl/actions/workflows/CI.yml/badge.svg?branch=main)](https://github.com/MilesCranmer/DispatchDoctor.jl/actions/workflows/CI.yml?query=branch%3Amain)
[![codecov](https://codecov.io/gh/MilesCranmer/DispatchDoctor.jl/branch/main/graph/badge.svg?token=tCOvkJPPDY)](https://codecov.io/gh/MilesCranmer/DispatchDoctor.jl)

[![DispatchDoctor](https://img.shields.io/badge/%F0%9F%A9%BA_tested_with-DispatchDoctor.jl-blue?labelColor=white)](https://github.com/MilesCranmer/DispatchDoctor.jl)

</div>

## 💊 Usage

This package provides the `@stable` macro
to enforce that functions have type stable return values.

```julia
using DispatchDoctor: @stable

@stable function relu(x)
    if x > 0
        return x
    else
        return 0.0
    end
end
```

Calling this function will throw an error for any type instability:

```julia
julia> relu(1.0)
1.0

julia> relu(0)
ERROR: TypeInstabilityError: Instability detected in function `relu`
with arguments `(Int64,)`. Inferred to be `Union{Float64, Int64}`,
which is not a concrete type.
```

Code which is type stable should safely compile away the check:

```julia
julia> @stable f(x) = x;
```

with `@code_llvm f(1)`:

```llvm
define i64 @julia_f_12055(i64 signext %"x::Int64") #0 {
top:
  ret i64 %"x::Int64"
}
```

Meaning there is zero overhead on this type stability check.
(This may not always be true, so be sure to try the workflow in [usage in packages](#-usage-in-packages))

You can use `@stable` on blocks of code,
including `begin-end` blocks, `module`, and anonymous functions.
The inverse of `@stable` is `@unstable` which turns it off:

```julia
@stable begin

    f() = rand(Bool) ? 0 : 1.0
    f(x) = x

    module A
        # Will apply to code inside modules:
        g(; a, b) = a + b

        # Will recursively apply to included files:
        include("myfile.jl")

        module B
            # as well as nested submodules!

            # `@unstable` inverts `@stable`:
            using DispatchDoctor: @unstable
            @unstable h() = rand(Bool) ? 0 : 1.0

            # This can also apply to code blocks:
            @unstable begin
                h(x::Int) = rand(Bool) ? 0 : 1.0
                # ^ And target specific methods
            end
        end
    end
end
```

All methods in the block will be wrapped with the type stability check:

```julia
julia> f()
ERROR: TypeInstabilityError: Instability detected in function `f`.
Inferred to be `Union{Float64, Int64}`, which is not a concrete type.
```

(*Tip: you cannot import or define macros within a `begin...end` block, unless it is at the "top level" of a submodule. So, if you are wrapping the contents of a package, you should either import any macros outside of `@stable begin...end`, or put them into a submodule.*)

(*Tip 2: in the REPL, you must wrap modules with `@eval`, because the REPL has special handling of the `module` keyword.*)

You can disable stability errors for a single scope
with the `allow_unstable` context:

```julia
julia> @stable f(x) = x > 0 ? x : 0.0

julia> allow_unstable() do
           f(1)
       end
1
```

although this will error if you try to use it simultaneously
from two separate threads.

### 🧪 Options

You can provide the following options to `@stable`:

- `default_mode::String="error"`:
  - Change the default mode from `"error"` to `"warn"` to only emit a warning, or `"disable"` to disable type instability checks by default.
  - To locally or globally override the mode for a package that uses DispatchDoctor, you can use the `"dispatch_doctor_mode"` key in your LocalPreferences.toml (typically configured with Preferences.jl).
- `default_codegen_level::String="debug"`:
  - Set the code generation level to `"min"` to only generate a single function body for each stabilized function. The default, `"debug"`, generates an entire duplicate function so that `@code_warntype` can be used.
  - To locally or globally override the code generation level for a package that uses DispatchDoctor, you can use the `"dispatch_doctor_codegen_level"` key in your LocalPreferences.toml.
- `default_union_limit::Int=1`:
  - Sets the maximum elements in a union to be considered stable. The default is `1`, meaning that all unions are considered unstable. A value of `2` would indicate that `Union{Float32,Float64}` is considered stable, but `Union{Float16,Float32,Float64}` is not.
  - To locally or globally override the union limit for a package that uses DispatchDoctor, you can use the `"dispatch_doctor_union_limit"` key in your LocalPreferences.toml.

Each of these is denoted a `default_` because you may set them globally or at a per-package level with `Preferences.jl` (see below).

### 🚑 Usage in packages

You might find it useful to *only* enable `@stable` during unit-testing,
to have it check every function in a library, but not throw errors for
downstream users. You may also want to have warnings instead of errors.

For this, use the `default_mode` keyword to set the default behavior:

```julia
module MyPackage
using DispatchDoctor
@stable default_mode="disable" begin

# Entire package code

end
end
```

`"disable"` as the mode will turn `@stable` into a *no-op*, so that
DispatchDoctor has no effect on your code by default.

The mode is configurable
via [Preferences.jl](https://github.com/JuliaPackaging/Preferences.jl),
meaning that, within your `test/runtests.jl`, you could add a line **before importing your package**:

```julia
using Preferences: set_preferences!

set_preferences!("MyPackage", "dispatch_doctor_mode" => "error")
```

You can also set to be `"warn"` if you would just like warnings.

You might also find it useful to set
the `default_codegen_level` parameter to `"min"` instead of
the default `"debug"`. This will result in no code duplication,
improving precompilation time (although `@code_warntype` and error
messages will be less useful).
As with the `default_mode`, you can configure the codegen level with Preferences.jl
by using the `"dispatch_doctor_codegen_level"` key.

Note that for code coverage to work as expected over stabilized code,
you will also need to use `default_codegen_level="min"`.

## 🔬 Special Cases

> [!NOTE]
> There are several scenarios and special cases for which type instabilities will be ignored. These are discussed below.

1. **During precompilation.**
2. **In unsupported Julia versions** (currently only [1.10.0, 1.12.0) are active)
3. **When loading code changes with Revise.jl\*.**
   - \*Basically, `@stable` will attempt to travel through any `include`'s. However, if you edit the included file and load the changes with Revise.jl, instability checks will get stripped (see [Revise#634](https://github.com/timholy/Revise.jl/issues/634)). The result will be that the `@stable` will be ignored.
4. **Within certain code blocks and function types:**
    - Within an `@unstable` block
    - Within a `@generated` block
    - Within any function containing a `@nospecialize` macro
	- Within a `quote ... end` block
	- Within a `macro ... end` block
	- Within an incompatible macro, such as
		- `@eval`
		- `@assume_effects`
		- `@pure`
		- Or anything else registered as incompatible with `register_macro!`
	- Parameterized functions like `MyType{T}(args...) = ...`
	- Functions with an expression-based name like `(::MyType)(args...) = ...`
	- A function inside another function (a closure).
		- But note the outer function will still be stabilized. So, e.g., `@stable f(x) = map(xi -> xi^2, x)` would stabilize `f`, but not `xi -> xi^2`. Though if `xi -> xi^2` were unstable, `f` would likely be as well, and it would get caught!

Note that you can safely use `@stable` over all of these cases, and special cases will automatically be skipped. Although, if you use `@stable` internally in some of these cases, like calling `@stable` within a function on a closure, such as directly on the `xi -> xi^2`, then it can still apply.



## 🩹 Eliminating Type Instabilities

Say that you start using `@stable` and you run into a type instability error.
What then? How should you fix it?

The first thing you can try is using `@code_warntype` on the
function in question, which will highlight each individual variable's
type with a special color for any instabilities.

Note that some of the lines you will see are from DispatchDoctor's inserted
code. If those are bothersome, you can disable the checking with
`Preferences.set_preferences!("MyPackage", "dispatch_doctor_mode" => "disable")`
followed by restarting Julia.

Other, much more powerful options to try include
[Cthulhu.jl](https://github.com/JuliaDebug/Cthulhu.jl) and
[JET.jl](https://github.com/aviatesk/JET.jl/), which can
provide more detailed type instability reports in an easier-to-read
format than `@code_warntype`. Both packages can also descend into
your function calls to help you locate the source of the instability.

## 🦠 Caveats

- Using `@stable` is likely to increase precompilation time. (To reduce this effect, try the `default_codegen_level` above)
- Using `@stable` over an entire package may result in flagging type instabilities on small functions that act as aliases and may otherwise be inlined by the Julia compiler. Try putting `@unstable` on any suspected such functions if needed.

## 🧑‍⚕️ Credits

Many thanks to @chriselrod and @thofma for tips on this
[discourse thread](https://discourse.julialang.org/t/improving-speed-of-runtime-dispatch-detector/114697).

"""This module interfaces with Preferences.jl"""
module _Preferences

using Preferences: load_preference, has_preference, get_uuid

struct StabilizationOptions
    mode::String
    codegen_level::String
    union_limit::Int
end

const GLOBAL_DEFAULT_MODE = "error"
const GLOBAL_DEFAULT_CODEGEN_LEVEL = "debug"
const GLOBAL_DEFAULT_UNION_LIMIT = 1

@enum IsCached::Bool begin
    Cached
    NotCached
end
struct Cache{A,B}
    cache::Dict{A,B}
    lock::Threads.SpinLock

    Cache{A,B}() where {A,B} = new{A,B}(Dict{A,B}(), Threads.SpinLock())
end

const UUID_CACHE = Cache{UInt64,Base.UUID}()
const PREFERENCE_CACHE = (;
    mode=Cache{Base.UUID,Tuple{String,IsCached}}(),
    codegen_level=Cache{Base.UUID,Tuple{String,IsCached}}(),
    union_limit=Cache{Base.UUID,Tuple{Int,IsCached}}(),
)
# All of our preferences are compile-time only, so we can safely cache them

function _cached_call(f::F, cache::Cache, key) where {F}
    lock(cache.lock) do
        get!(cache.cache, key) do
            f()
        end
    end
end
function _cached_get_uuid(m)
    _cached_call(UUID_CACHE, objectid(m)) do
        try
            get_uuid(m)
        catch
            Base.UUID(0)
        end
    end
end

function get_preferred(
    default, cache, calling_module, key, deprecated_keys::Vector{String}=String[]
)
    uuid = _cached_get_uuid(calling_module)
    # ^Surprisingly it takes 600 us to get the UUID, so its worth the cache!
    # TODO: Though, this might need to be changed if Revise.jl becomes compatible
    (value, cached) = _cached_call(cache, uuid) do
        if has_preference(uuid, key)
            (load_preference(uuid, key), Cached)
        elseif (i = findfirst(Base.Fix1(has_preference, uuid), deprecated_keys)) !== nothing
            Base.depwarn(
                "The preference key `$(deprecated_keys[i])` is deprecated. Please use `$key` instead.",
                :get_preferred,
            )
            (load_preference(uuid, deprecated_keys[i]), Cached)
        else
            (default, NotCached)
        end
    end
    if cached == Cached
        return value
    else
        return default
    end
end
function get_all_preferred(options::StabilizationOptions, calling_module)
    mode = get_preferred(
        options.mode,
        PREFERENCE_CACHE.mode,
        calling_module,
        "dispatch_doctor_mode",
        ["instability_check"],
    )
    if mode == "disable"
        # Short circuit and quit early
        return StabilizationOptions("disable", options.codegen_level, options.union_limit)
    end
    return StabilizationOptions(
        mode,
        get_preferred(
            options.codegen_level,
            PREFERENCE_CACHE.codegen_level,
            calling_module,
            "dispatch_doctor_codegen_level",
            ["instability_check_codegen_level", "instability_check_codegen"],
        ),
        get_preferred(
            options.union_limit,
            PREFERENCE_CACHE.union_limit,
            calling_module,
            "dispatch_doctor_union_limit",
            ["instability_check_union_limit"],
        ),
    )
end

end

using DispatchDoctor
using Documenter

DocMeta.setdocmeta!(DispatchDoctor, :DocTestSetup, :(using DispatchDoctor); recursive=true)

readme = open(dirname(@__FILE__) * "/../README.md") do io
    read(io, String)
end

# We replace every instance of <img src="IMAGE" ...> with ![](IMAGE).
readme = replace(readme, r"<img src=\"([^\"]+)\"[^>]+>.*" => s"![](\1)")

# Then, we remove any line with "<div" on it:
readme = replace(readme, r"<[/]?div.*" => s"")

# Finally, we read in file docs/src/index_base.md:
index_base = open(dirname(@__FILE__) * "/src/index_base.md") do io
    read(io, String)
end

# And then we create "/src/index.md":
open(dirname(@__FILE__) * "/src/index.md", "w") do io
    write(io, readme)
    write(io, "\n")
    write(io, index_base)
end

makedocs(;
    modules=[DispatchDoctor],
    authors="MilesCranmer <miles.cranmer@gmail.com> and contributors",
    repo="https://github.com/MilesCranmer/DispatchDoctor.jl/blob/{commit}{path}#{line}",
    sitename="DispatchDoctor.jl",
    format=Documenter.HTML(;
        prettyurls=get(ENV, "CI", "false") == "true",
        canonical="https://ai.damtp.cam.ac.uk/dispatchdoctor",
        edit_link="main",
        assets=String[],
    ),
    pages=["Home" => "index.md", "Reference" => "reference.md"],
    warnonly=[:missing_docs],
)

deploydocs(; repo="github.com/MilesCranmer/DispatchDoctor.jl", devbranch="main")

# Mirror to DAMTP:
ENV["DOCUMENTER_KEY"] = ENV["DOCUMENTER_KEY_CAM"]
ENV["GITHUB_REPOSITORY"] = "ai-damtp-cam-ac-uk/dispatchdoctor.git"
deploydocs(;
    repo="github.com/ai-damtp-cam-ac-uk/dispatchdoctor.git",
    devbranch="main"
)

"""This module holds the main processing functions for `@stable`"""
module _Stabilization

using MacroTools: @capture, @q, combinedef, splitdef, isdef, longdef, rmlines, prewalk

using .._Utils:
    specializing_typeof,
    map_specializing_typeof,
    _promote_op,
    is_function_name_compatible,
    get_first_source_info,
    sanitize_arg_for_stability_check,
    extract_symbol,
    type_instability,
    type_instability_limit_unions,
    has_nospecialize
using .._Errors: TypeInstabilityError, TypeInstabilityWarning
using .._Interactions:
    ignore_function,
    get_macro_behavior,
    IncompatibleMacro,
    CompatibleMacro,
    DontPropagateMacro
using .._RuntimeChecks: is_precompiling, checking_enabled
using .._ParseOptions: parse_options

function _stable(args...; calling_module, source_info, kws...)
    raw_options, ex = args[begin:(end - 1)], args[end]
    options = parse_options(raw_options, calling_module)

    if options.mode in ("error", "warn")
        out, metadata = _stabilize_all(
            ex,
            DownwardMetadata();
            source_info,
            kws...,
            options.mode,
            options.codegen_level,
            options.union_limit,
        )
        if metadata.matching_function == 0
            @warn(
                "`@stable` found no compatible functions to stabilize",
                source_info = source_info,
                calling_module = calling_module,
            )
        end
        return out
    else # if mode == "disable"
        return ex
    end
end

"""To communicate to the parent of the recursion."""
Base.@kwdef struct UpwardMetadata
    matching_function::Bool = false
    unused_macros::Vector{Any} = Any[]
    macro_keys::Vector{Symbol} = Symbol[]
end

function merge(a::UpwardMetadata, b::UpwardMetadata)
    @assert isempty(a.unused_macros) &&
        isempty(b.unused_macros) &&
        isempty(a.macro_keys) &&
        isempty(b.macro_keys)
    return UpwardMetadata(; matching_function=a.matching_function || b.matching_function)
end

"""To communicate to the leafs of the recursion."""
Base.@kwdef struct DownwardMetadata
    macros_to_use::Vector{Any} = Any[]
    macro_keys::Vector{Symbol} = Symbol[]
end

function UpwardMetadata(downward_metadata::DownwardMetadata; matching_function::Bool=false)
    return UpwardMetadata(;
        unused_macros=deepcopy(downward_metadata.macros_to_use),
        macro_keys=deepcopy(downward_metadata.macro_keys),
        matching_function,
    )
end

function _stabilize_all(ex, downward_metadata::DownwardMetadata; kws...)
    return ex, UpwardMetadata(downward_metadata)
end
function _stabilize_all(ex::Expr, downward_metadata::DownwardMetadata; kws...)
    #! format: off
    if ex.head == :macrocall
        macro_behavior = get_macro_behavior(ex.args[1])
        if macro_behavior == IncompatibleMacro
            return ex, UpwardMetadata(downward_metadata)
        elseif macro_behavior == CompatibleMacro
            # We build up a stack of macros to propagate to the function call
            # push!(macro_stack, ex.args[1:end-1])
            my_key = gensym()
            macros_to_use = deepcopy(downward_metadata.macros_to_use)
            macro_keys = deepcopy(downward_metadata.macro_keys)
            push!(macros_to_use, ex.args[1:end-1])
            push!(macro_keys, my_key)

            new_downward_metadata = DownwardMetadata(; macros_to_use, macro_keys)
            inner_ex, upward_metadata = _stabilize_all(ex.args[end], new_downward_metadata; kws...)

            if isempty(upward_metadata.unused_macros)
                # It has been applied! So we just return the inner part
                return inner_ex, upward_metadata
            else
                # Not applied, so we have to paste the macro back on
                @assert upward_metadata.macro_keys[end] == my_key
                @assert length(upward_metadata.unused_macros) == length(upward_metadata.macro_keys)

                new_ex = Expr(:macrocall, upward_metadata.unused_macros[end]..., inner_ex)
                new_upward_metadata = UpwardMetadata(; 
                    matching_function = upward_metadata.matching_function,
                    unused_macros = upward_metadata.unused_macros[1:end-1],
                    macro_keys = upward_metadata.macro_keys[1:end-1],
                )
                return new_ex, new_upward_metadata
            end
        else
            @assert macro_behavior == DontPropagateMacro

            # Apply to last argument only
            inner_ex, upward_metadata = _stabilize_all(ex.args[end], downward_metadata; kws...)
            new_ex = Expr(:macrocall, ex.args[1:end-1]..., inner_ex)
            return new_ex, upward_metadata
        end
    elseif ex.head == :macro
        # Do nothing inside macros (in case of closure)
        return ex, UpwardMetadata(downward_metadata)
    elseif ex.head == :quote
        # Do nothing inside of quotes
        return ex, UpwardMetadata(downward_metadata)
    elseif ex.head == :global
        # Incompatible with two functions
        return ex, UpwardMetadata(downward_metadata)
    elseif ex.head == :module
        return _stabilize_module(ex, downward_metadata; kws...)
    elseif ex.head == :call && ex.args[1] == Symbol("include") && length(ex.args) == 2
        # We can't track the matches in includes, so just assume
        # there are some matches. TODO: However, this is not a great solution.
        # Replace include with DispatchDoctor version
        matching_function = true
        return :($(_stabilizing_include)(@__MODULE__, $(ex.args[2]); $(kws)...)), UpwardMetadata(downward_metadata; matching_function)
    elseif isdef(ex) && @capture(longdef(ex), function (fcall_ | fcall_) body_ end)
        #               ^ This is the same check done by `splitdef`
        # TODO: Should report `isdef` to MacroTools as not capturing all cases
        return _stabilize_fnc(ex, downward_metadata; kws...)
    else
        stabilized_args = map(e -> _stabilize_all(e, DownwardMetadata(); kws...), ex.args)
        merged_upward_metadata = reduce(merge, map(last, stabilized_args); init=UpwardMetadata())
        new_ex = Expr(ex.head, map(first, stabilized_args)...)
        return new_ex, UpwardMetadata(downward_metadata; matching_function=merged_upward_metadata.matching_function)
    end
    #! format: on
end

function _stabilizing_include(m::Module, path; kws...)
    inner = let kws = kws
        (ex,) -> let
            new_ex, upward_metadata = _stabilize_all(ex, DownwardMetadata(); kws...)
            @assert isempty(upward_metadata.unused_macros)
            new_ex
        end
    end
    return m.include(inner, path)
end

function _stabilize_module(ex, downward_metadata; kws...)
    stabilized_args = map(
        e -> _stabilize_all(e, DownwardMetadata(); kws...), ex.args[3].args
    )
    merged_upward_metadata = reduce(
        merge, map(last, stabilized_args); init=UpwardMetadata()
    )
    new_ex = Expr(
        :module, ex.args[1], ex.args[2], Expr(:block, map(first, stabilized_args)...)
    )
    return new_ex,
    UpwardMetadata(
        downward_metadata; matching_function=merged_upward_metadata.matching_function
    )
end

_show_warning(w::TypeInstabilityWarning) = (@warn w; nothing)
_construct_pairs(x, y) = x .=> y

function _stabilize_fnc(
    fex::Expr,
    downward_metadata::DownwardMetadata;
    mode::String="error",
    codegen_level::String="debug",
    union_limit::Int=0,
    source_info::Union{LineNumberNode,Nothing}=nothing,
)
    func = splitdef(fex)

    if haskey(func, :params) && length(func[:params]) > 0
        # Incompatible with parameterized functions
        return fex, UpwardMetadata(downward_metadata)
    elseif haskey(func, :name) && !is_function_name_compatible(func[:name])
        return fex, UpwardMetadata(downward_metadata)
    end

    func_simulator = splitdef(deepcopy(fex))

    # Load any information about the source
    searched_source_info = get_first_source_info(fex)
    source_info = if searched_source_info isa LineNumberNode
        string(searched_source_info.file, ":", searched_source_info.line)
    elseif source_info isa LineNumberNode
        string(source_info.file, ":", source_info.line)
    else
        nothing
    end

    if haskey(func, :name)
        name = string(func[:name])
        print_name = string("`", name, "`")
    else
        name = "anonymous_function"
        print_name = "anonymous function"
    end

    args, destructurings = let
        args_destructurings = map(sanitize_arg_for_stability_check, func[:args])
        (
            map(first, args_destructurings),
            filter(!isnothing, map(last, args_destructurings)),
        )
    end

    # Check for @nospecialize anywhere in the original args or kwargs
    if any(has_nospecialize, func[:args]) || any(has_nospecialize, func[:kwargs])
        return fex, UpwardMetadata(downward_metadata)
    end

    kwargs = func[:kwargs]
    where_params = func[:whereparams]

    func[:args] = args

    arg_symbols = map(extract_symbol, args)
    kwarg_symbols = map(extract_symbol, kwargs)
    where_param_symbols = map(extract_symbol, where_params)

    simulator = gensym(string(name, "_simulator"))
    T = gensym(string(name, "_return_type"))

    err = if mode == "error"
        :(throw(
            $(TypeInstabilityError)(
                $(print_name),
                $(source_info),
                ($(arg_symbols...),),
                (; $(kwarg_symbols...)),
                ($(_construct_pairs)($(where_param_symbols), ($(where_param_symbols...),))),
                $T,
            ),
        ))
    elseif mode == "warn"
        :($(_show_warning)(
            $(TypeInstabilityWarning)(
                $(print_name),
                $(source_info),
                ($(arg_symbols...),),
                (; $(kwarg_symbols...)),
                ($(_construct_pairs)($(where_param_symbols), ($(where_param_symbols...),))),
                $T,
            ),
        ))
    else
        error("Unknown mode: $mode. Please use \"error\" or \"warn\".")
    end

    typeof_args = :($(map_specializing_typeof)(($(arg_symbols...),)))
    infer = if isempty(kwarg_symbols)
        :($(_promote_op)($simulator, $(typeof_args)...))
    else
        :($(_promote_op)(
            Core.kwcall,
            typeof((; $(kwarg_symbols...))),
            typeof($simulator),
            $(typeof_args),
        ))
    end

    checker = if union_limit > 1
        :($(type_instability_limit_unions)($T, Val($union_limit)))
    else
        :($(type_instability)($T))
    end

    caller = if codegen_level == "debug"
        # We duplicate entire body, so `@code_warntype` works
        body = func[:body]
        # and we also destructure the signature
        Expr(:block, destructurings..., body)
    elseif isempty(kwarg_symbols)
        :($simulator($(arg_symbols...)))
    else
        :($simulator($(arg_symbols...); $(kwarg_symbols...)))
    end

    ignore = haskey(func, :name) ? :($(ignore_function)(var"#self#")) : :(false)

    func_simulator[:name] = simulator
    func_simulator[:body] = if codegen_level == "debug"
        prewalk(rmlines, func_simulator[:body])
    else
        func_simulator[:body]
    end
    func[:body] = @q begin
        $T = $infer
        if $(checker) && !$ignore && $(checking_enabled)()
            $err
        end

        $(caller)
    end

    func_simulator_ex = combinedef(func_simulator)
    func_ex = combinedef(func)

    # We apply other macros to both the function and the simulator
    for macro_element in Iterators.reverse(downward_metadata.macros_to_use)
        func_ex = Expr(:macrocall, macro_element..., func_ex)
        func_simulator_ex = Expr(:macrocall, macro_element..., func_simulator_ex)
    end

    final_ex = @q begin
        $(func_simulator_ex)
        $(Base).@__doc__ $(func_ex)
    end
    return final_ex, UpwardMetadata(; matching_function=true)  # Clean metadata – all macros were consumed
end

end

module DispatchDoctorChainRulesCoreExt

using ChainRulesCore: @ignore_derivatives, @non_differentiable
import DispatchDoctor._RuntimeChecks: is_precompiling, checking_enabled
import DispatchDoctor._Stabilization: _show_warning, _construct_pairs
import DispatchDoctor._Utils:
    specializing_typeof,
    map_specializing_typeof,
    _promote_op,
    type_instability,
    type_instability_limit_unions

# Issue #32
@non_differentiable _show_warning(::Any...)
@non_differentiable _construct_pairs(::Any...)

# Issue #46
@non_differentiable specializing_typeof(::Any)
@non_differentiable map_specializing_typeof(::Any...)
@non_differentiable _promote_op(::Any...)
@non_differentiable type_instability(::Any...)
@non_differentiable type_instability_limit_unions(::Any...)

# foreigncall expressions
@non_differentiable is_precompiling()
@non_differentiable checking_enabled()

end

"""This module contains various utility functions"""
module _Utils

using MacroTools: @capture

# Compatible Julia versions
const JULIA_OK = let
    JULIA_LOWER_BOUND = v"1.10.0-DEV.0"
    JULIA_UPPER_BOUND = v"1.13.0-DEV.0"
    # TODO: Get exact lower/upper bounds

    VERSION >= JULIA_LOWER_BOUND && VERSION < JULIA_UPPER_BOUND
end

struct Unknown
    msg::String
end

# Used to check if a function name is compatible with `@stable`
is_function_name_compatible(ex) = false
is_function_name_compatible(ex::Symbol) = true
is_function_name_compatible(ex::Expr) = ex.head == :(.) && all(is_symbol_like, ex.args)
is_symbol_like(ex) = false
is_symbol_like(ex::QuoteNode) = is_symbol_like(ex.value)
is_symbol_like(ex::Symbol) = true

function extract_symbol(ex::Symbol, fullex=ex)
    if ex == Symbol("_")
        return Unknown("_")
    else
        return ex
    end
end
function extract_symbol(ex::Expr, fullex=ex)
    #! format: off
    if ex.head == :(::) && length(ex.args) > 1 && @capture(ex.args[2], Vararg | Vararg{_} | Vararg{_,_})
        return :($(ex.args[1])...)
    elseif ex.head in (:kw, :(::), :(<:))
        out = extract_symbol(ex.args[1], ex)
        return out isa Unknown ? Unknown(string(ex)) : out
    elseif ex.head == :(...) && ex.args[1] isa Expr && ex.args[1].head == :(::)
        # Such as `a::Int...`
        return :($(ex.args[1].args[1])...)
    elseif ex.head in (:tuple, :(...))
        return ex
    else
        return Unknown(string(ex))
    end
    #! format: on
end

"""
Amend args that do not have a symbol or are destructured in the signature. Return gensymmed
arg expression and, if needed, an equivalent destructuring assignment for the body.
"""
function sanitize_arg_for_stability_check(
    ex::Symbol
)::Tuple{Union{Expr,Symbol},Union{Expr,Nothing}}
    if ex == :(_)
        arg = gensym("arg")
        return arg, Expr(:(=), ex, arg)
    else
        return ex, nothing
    end
end
function sanitize_arg_for_stability_check(
    ex::Expr
)::Tuple{Union{Expr,Symbol},Union{Expr,Nothing}}
    head, args = ex.head, ex.args
    if head == :(tuple)
        # (Base case)
        # matches things like (x,) and (; x)
        arg = gensym("arg")
        return arg, Expr(:(=), ex, arg)
    elseif head == :(::) && length(args) == 1
        # (Base case)
        # matches things like `::T`
        arg = gensym("arg")
        return Expr(head, arg, only(args)), nothing
    elseif head == :(...) && length(args) == 1
        # (Composite case)
        # matches things like `::Int...`
        arg_ex, destructure_ex = sanitize_arg_for_stability_check(only(args))
        return Expr(head, arg_ex), destructure_ex
    elseif head in (:kw, :(::)) && length(args) == 2
        # (Composite case)
        # :(::) => matches things like `(x,)::T` and `(; x)::T`
        # :kw => matches things like `::Type{T}=MyType`
        arg_ex, destructure_ex = sanitize_arg_for_stability_check(first(args))
        return Expr(head, arg_ex, last(args)), destructure_ex
    else
        return ex, nothing
    end
end

get_first_source_info(ex) = nothing
get_first_source_info(l::LineNumberNode) = l
function get_first_source_info(s::Expr)
    for arg in s.args
        extracted_arg = get_first_source_info(arg)
        if extracted_arg isa LineNumberNode
            return extracted_arg
        end
    end
    return nothing
end

# typeof but returns Type{T} for a type T input
specializing_typeof(::T) where {T} = T
specializing_typeof(::Type{T}) where {T} = Type{T}
specializing_typeof(arg::Type{<:Type}) = typeof(arg)
specializing_typeof(::Val{T}) where {T} = Val{T}
map_specializing_typeof(args::Tuple) = map(specializing_typeof, args)

function _promote_op(f::F, S::Vararg{Type,N}) where {F,N}
    return Base.promote_op(f, S...)
end
@static if isdefined(Core, :kwcall)
    function _promote_op(
        ::typeof(Core.kwcall), ::Type{Kwargs}, ::Type{F}, S::Tuple
    ) where {Kwargs,F}
        return Base.promote_op(Core.kwcall, Kwargs, F, S...)
    end
end

"""
    type_instability(T::Type)

Returns true if this type is not concrete. Will also
return false for `Union{}`, so that errors can propagate.
"""
@inline type_instability(::Type{T}) where {T} = !Base.isconcretetype(T)
@inline type_instability(::Type{Union{}}) = false  # LCOV_EXCL_LINE

@static if Base.isdefined(Core, :TypeofBottom)
    @inline type_instability(::Type{Core.TypeofBottom}) = false  # LCOV_EXCL_LINE
end

# Weirdly, Base.isconcretetype flags Type{T} itself as not concrete,
# so we implement a workaround.
@inline type_instability(::Type{Type{T}}) where {T} = type_instability(T)

@inline function type_instability_limit_unions(
    T::Core.TypeofVararg, ::Val{union_limit}
) where {union_limit}
    # Treat it as unstable unless BOTH parameters are concrete *and* the
    # element type itself is stable.
    return !isdefined(T, :T) ||
           !isdefined(T, :N) ||
           type_instability_limit_unions(T.T, Val(union_limit))
end

@inline function type_instability_limit_unions(
    ::Type{T}, ::Val{union_limit}
) where {T,union_limit}
    if T isa UnionAll
        return true
    elseif T <: Tuple && !(T isa Union) && hasproperty(T, :types)
        return any(Base.Fix2(type_instability_limit_unions, Val(union_limit)), T.types)
    else
        return _type_instability_recurse_unions(T) || _count_unions(T) > union_limit
    end
end

function _count_unions(::Type{T}) where {T}
    if T isa Union
        return 1 + _count_unions(T.b)
    else
        return 1
    end
end

function _type_instability_recurse_unions(::Type{T}) where {T}
    if T isa Union
        type_instability(T.a) || _type_instability_recurse_unions(T.b)
    else
        type_instability(T)
    end
end

"""
Recursively search an expression for @nospecialize macro
"""
function has_nospecialize(ex::Expr)
    if ex.head == :macrocall && ex.args[1] == Symbol("@nospecialize")
        return true
    end
    return any(has_nospecialize, ex.args)
end
has_nospecialize(::Any) = false  # LCOV_EXCL_LINE

end

using DispatchDoctor
using InteractiveUtils: code_llvm
using Test: @test

@stable f(x) = x
# Test that the LLVM IR is only 4 SLOC and
# therefore doesn't include the check
llvm_ir = sprint((args...) -> code_llvm(args...; debuginfo=:none), f, (Int,))

lines = split(llvm_ir, "\n")
filter!(l -> !isempty(l), lines)
filter!(l -> !startswith(l, ";"), lines)

# If Julia failed to optimize the code, we should expect
# to see some GC pool allocations:
@test !occursin(llvm_ir, "gc_pool_alloc")

# We can also test explicit number of lines:
if length(lines) != 4
    @show lines
end
@test length(lines) == 4

"""This module parses the options for the `@stable` macro"""
module _ParseOptions

using .._Preferences:
    get_all_preferred,
    GLOBAL_DEFAULT_MODE,
    GLOBAL_DEFAULT_CODEGEN_LEVEL,
    GLOBAL_DEFAULT_UNION_LIMIT,
    StabilizationOptions

function parse_options(options, calling_module)
    # Standard defaults:
    mode = GLOBAL_DEFAULT_MODE
    codegen_level = GLOBAL_DEFAULT_CODEGEN_LEVEL
    union_limit = GLOBAL_DEFAULT_UNION_LIMIT

    # Deprecated
    warnonly = nothing
    enable = nothing

    for option in options
        if option isa Expr && option.head == :(=)
            if option.args[1] == :warnonly
                warnonly = option.args[2]
                continue
            elseif option.args[1] == :enable
                enable = option.args[2]
                continue
            elseif option.args[1] == :default_mode
                mode = option.args[2]
                continue
            elseif option.args[1] == :default_codegen_level
                codegen_level = option.args[2]
                continue
            elseif option.args[1] == :default_union_limit
                union_limit = option.args[2]
                continue
            end
        end
        error("Unknown macro option: $option")
    end

    mode = _parse_even_if_expr(mode, calling_module, String)
    codegen_level = _parse(codegen_level, String)
    union_limit = _parse(union_limit, Int)

    _validate_mode(mode)
    _validate_codegen_level(codegen_level)

    # Deprecated
    warnonly = _parse_even_if_expr(warnonly, calling_module, Bool)
    enable = _parse_even_if_expr(enable, calling_module, Bool)

    mode = if enable !== nothing
        @warn "The `enable` option is deprecated. Please use `default_mode` instead, either \"error\", \"warn\", or \"disable\"."
        if warnonly !== nothing
            @warn "The `warnonly` option is deprecated. Please use `default_mode` instead, either \"error\", \"warn\", or \"disable\"."
            warnonly ? "warn" : (enable ? "error" : "disable")
        else
            enable ? "error" : "disable"
        end
    else
        mode
    end

    options = StabilizationOptions(mode, codegen_level, union_limit)

    if calling_module != Core.Main
        # Local setting from Preferences.jl overrides defaults
        return get_all_preferred(options, calling_module)
    else
        return options
    end
end

function _validate_mode(mode)
    if mode ∉ ("error", "warn", "disable")
        error("Unknown mode: $mode. Please use \"error\", \"warn\", or \"disable\".")
    end
    return nothing
end
function _validate_codegen_level(codegen_level)
    if codegen_level ∉ ("debug", "min")
        error("Unknown codegen level: $codegen_level. Please use \"debug\" or \"min\".")
    end
    return nothing
end

# TODO: Deprecate passing expressions
function _parse_even_if_expr(ex::Expr, calling_module, ::Type{T}) where {T}
    return Core.eval(calling_module, ex)::T
end
_parse_even_if_expr(::Nothing, _, ::Type{T}) where {T} = nothing
_parse_even_if_expr(ex, _, ::Type{T}) where {T} = _parse(ex, T)
_parse(::Nothing, ::Type{T}) where {T} = nothing
_parse(ex::QuoteNode, ::Type{T}) where {T} = ex.value::T
_parse(ex, ::Type{T}) where {T} = ex::T

end

module DispatchDoctor

export @stable, @unstable, allow_unstable, TypeInstabilityError, register_macro!

include("utils.jl")
include("errors.jl")
include("printing.jl")
include("runtime_checks.jl")
include("preferences.jl")
include("macro_interactions.jl")
include("parse_options.jl")
include("stabilization.jl")
include("macros.jl")

#! format: off
using ._Utils: extract_symbol, JULIA_OK, Unknown, specializing_typeof, type_instability, type_instability_limit_unions
using ._Errors: TypeInstabilityError, TypeInstabilityWarning, AllowUnstableDataRace
using ._Preferences
using ._Printing
using ._Interactions: MACRO_BEHAVIOR, MacroInteractions, CompatibleMacro, IncompatibleMacro, DontPropagateMacro, register_macro!, get_macro_behavior, ignore_function
using ._RuntimeChecks: INSTABILITY_CHECK_ENABLED, allow_unstable, is_precompiling
using ._Stabilization: _stable, _stabilize_all, _stabilize_fnc, _stabilize_module
using ._Macros: @stable, @unstable
#! format: on

end

"""This module describes interactions between `@stable` and other macros and functions"""
module _Interactions

"""
An enum to describe the behavior of macros when interacting with `@stable`.

- `CompatibleMacro`: Propagate macro through to both function and simulator.
- `DontPropagateMacro`: Do not propagate macro; leave it at the outer block.
- `IncompatibleMacro`: Skip the contents of this macro completely.
"""
@enum MacroInteractions begin
    CompatibleMacro
    DontPropagateMacro
    IncompatibleMacro
end

# Macros we dont want to propagate
const MACRO_BEHAVIOR = (;
    table=Dict([
        Symbol("@stable") => IncompatibleMacro,             # <self>
        # ^ We don't want to stabilize a function twice.
        Symbol("@unstable") => IncompatibleMacro,           # <self>
        # ^ This is the purpose of `@unstable`
        Symbol("@doc") => DontPropagateMacro,               # Core
        # ^ Base.@__doc__ takes care of this.
        Symbol("@assume_effects") => IncompatibleMacro,     # Base
        # ^ Some effects are incompatible, like
        #   :nothrow, so this requires much more
        #   work to get working. TODO.
        Symbol("@enum") => IncompatibleMacro,               # Base
        # ^ TODO. Seems to interact.
        Symbol("@eval") => IncompatibleMacro,               # Base
        # ^ Too much flexibility to apply,
        #   and user could always use `@eval`
        #   inside function.
        Symbol("@deprecate") => IncompatibleMacro,          # Base
        # ^ TODO. Seems to interact.
        Symbol("@generated") => IncompatibleMacro,          # Base
        # ^ In principle this is compatible but
        #   needs additional logic to work.
        Symbol("@opaque") => IncompatibleMacro,             # Base.Experimental
        # ^ TODO. Seems to interact.
        Symbol("@kwdef") => IncompatibleMacro,              # Base
        # ^ TODO. Seems to interact.
        Symbol("@pure") => IncompatibleMacro,               # Base
        # ^ See `@assume_effects`.
        Symbol("@everywhere") => DontPropagateMacro,        # Distributed
        # ^ Prefer to have block passed to workers
        #   only a single time. And `@everywhere`
        #   works with blocks of code, so it is
        #   fine.
        Symbol("@model") => IncompatibleMacro,              # Turing
        # ^ Fairly common macro used to define
        #   probabilistic models. The syntax is
        #   incompatible with `@stable`.
        Symbol("@capture") => IncompatibleMacro,            # MacroTools
        # ^ Similar to `@model`.
    ]),
    lock=Threads.SpinLock(),
)
function get_macro_behavior(_)
    return CompatibleMacro
end
function get_macro_behavior(ex::Symbol)
    Base.@lock MACRO_BEHAVIOR.lock get(MACRO_BEHAVIOR.table, ex, CompatibleMacro)
end
function get_macro_behavior(ex::QuoteNode)
    return get_macro_behavior(ex.value)
end
function get_macro_behavior(ex::Expr)
    parts = map(get_macro_behavior, ex.args)
    return reduce(combine_behavior, parts; init=CompatibleMacro)
end

function combine_behavior(a::MacroInteractions, b::MacroInteractions)
    if a == CompatibleMacro && b == CompatibleMacro
        return CompatibleMacro
    elseif a == IncompatibleMacro || b == IncompatibleMacro
        return IncompatibleMacro
    else
        return DontPropagateMacro
    end
end

"""
    register_macro!(macro_name::Symbol, behavior::MacroInteractions)

Register a macro with a specified behavior in the `MACRO_BEHAVIOR` list.

This function adds a new macro and its associated behavior to the global list that
tracks how macros should be treated when encountered during the stabilization
process. The behavior can be one of `CompatibleMacro`, `IncompatibleMacro`, or `DontPropagateMacro`,
which influences how the `@stable` macro interacts with the registered macro.

The default behavior for `@stable` is to assume `CompatibleMacro` unless explicitly declared.

# Arguments
- `macro_name::Symbol`: The symbol representing the macro to register.
- `behavior::MacroInteractions`: The behavior to associate with the macro, which dictates how it should be handled.

# Examples
```julia
using DispatchDoctor: register_macro!, IncompatibleMacro

register_macro!(Symbol("@mymacro"), IncompatibleMacro)
```
"""
function register_macro!(macro_name::Symbol, behavior::MacroInteractions)
    Base.@lock MACRO_BEHAVIOR.lock begin
        if haskey(MACRO_BEHAVIOR.table, macro_name)
            error(
                "Macro `$macro_name` already registered with behavior $(MACRO_BEHAVIOR.table[macro_name]).",
            )
        end
        MACRO_BEHAVIOR.table[macro_name] = behavior
        MACRO_BEHAVIOR.table[macro_name]
    end
end

"""
    ignore_function(f)

Globally ignore certain functions when stabilizing.
By default, a few functions in Base are ignored, as they are meant to
be unstable, and will (hopefully) always be inlined by the compiler.
"""
@inline ignore_function(f) = false
@inline function ignore_function(
    ::Union{map(typeof, (iterate, getproperty, setproperty!))...}
)
    return true
end

end

"""Test that `@stable` is compatible with Zygote"""
module ZygoteTest

using DispatchDoctor: @stable, TypeInstabilityError, _RuntimeChecks
using Zygote: gradient
using Test

# Issue https://github.com/MilesCranmer/DispatchDoctor.jl/issues/32
@stable default_mode = "warn" f(x) = x * x

@test gradient(f, 1.0) == (2.0,)

# Still want errors to show up:
@stable default_mode = "error" g(x) = x > 0 ? x : 0
@test_throws TypeInstabilityError gradient(g, 1.0)

# Issue https://github.com/MilesCranmer/DispatchDoctor.jl/issues/46
@stable h(x) = 1
@test_skip (@inferred gradient(h, 1.0))
# TODO: Fix Zygote inference

# Test foreign call expressions doesn't lead to errors
is_precompiling(x) = _RuntimeChecks.is_precompiling()
@test only(gradient(is_precompiling, 1.0)) === nothing

checking_enabled(x) = _RuntimeChecks.checking_enabled()
@test only(gradient(checking_enabled, 1.0)) === nothing

end

module _Printing

using .._Utils: specializing_typeof, Unknown
using .._Errors: AllowUnstableDataRace, TypeInstabilityError, TypeInstabilityWarning

Base.showerror(io::IO, e::AllowUnstableDataRace) = print(io, e.msg)

function _print_msg(io::IO, e::Union{TypeInstabilityError,TypeInstabilityWarning})
    print(
        io,
        "DispatchDoctor.TypeInstability",
        e isa TypeInstabilityError ? "Error" : "Warning",
        ": Instability detected in ",
        e.f,
    )
    if e.source_info !== nothing
        print(io, " defined at ", e.source_info)
    end
    parts = []
    if !isempty(e.args)
        push!(parts, "arguments `$(map(typeinfo, e.args))`")
    end
    if !isempty(e.kwargs)
        push!(parts, "keyword arguments `$(typeof(e.kwargs))`")
    end
    if !isempty(e.params)
        push!(parts, "parameters `$(e.params)`")
    end
    if !isempty(parts)
        print(io, " with ")
        join(io, parts, " and ")
    end
    print(io, ". ")
    return print(io, "Inferred to be `", e.return_type, "`, which is not a concrete type.")
end
typeinfo(x) = specializing_typeof(x)
typeinfo(u::Unknown) = u

Base.showerror(io::IO, e::TypeInstabilityError) = _print_msg(io, e)
Base.show(io::IO, w::TypeInstabilityWarning) = _print_msg(io, w)

Base.show(io::IO, u::Unknown) = print(io, string("[", u.msg, "]"))

end

"""Test that `@stable` is compatible with Enzyme"""
module EnzymeTest

using DispatchDoctor: @stable, TypeInstabilityError
using Enzyme: autodiff, Reverse, Active, Duplicated
using Test: @testset, @test, @test_throws

@testset "basic" begin
    @stable f1(x) = x * x
    @test first(autodiff(Reverse, f1, Active(1.0))[1]) ≈ 2.0
end

@testset "arrays" begin
    @stable f_caller(x::Array{Float64}) = x[1] * x[1] + x[2] * x[1]
    @stable f(x::Array{Float64}, y::Array{Float64}) = (y[1] = f_caller(x); nothing)
    @test let x = [2.0, 2.0], bx = [0.0, 0.0], y = [0.0], by = [1.0]
        autodiff(Reverse, f, Duplicated(x, bx), Duplicated(y, by))[1]
        bx ≈ [6.0, 2.0]
    end
end

@testset "with unstable" begin
    @stable f2(x) = rand(Bool) ? x : 1.0 * x
    @test_throws TypeInstabilityError begin
        autodiff(Reverse, f2, Active(1.0f0))
    end
end

@testset "cover rules" begin
    # Due to a bug in Coverage.jl, we call these explicitly
    @eval module CoverageRules
        using Enzyme: EnzymeRules
        using DispatchDoctor._RuntimeChecks: is_precompiling, checking_enabled
        using DispatchDoctor._Stabilization: _show_warning, _construct_pairs
        using DispatchDoctor._Utils:
            specializing_typeof,
            map_specializing_typeof,
            _promote_op,
            type_instability,
            type_instability_limit_unions

        using Test

        function test_all()
            for f in [
                is_precompiling,
                checking_enabled,
                _show_warning,
                _construct_pairs,
                specializing_typeof,
                map_specializing_typeof,
                _promote_op,
                type_instability,
                type_instability_limit_unions,
            ]
                f != specializing_typeof && @test EnzymeRules.inactive_noinl(f) === nothing
                @test EnzymeRules.inactive_noinl(f, 1) === nothing
            end
        end
    end
    CoverageRules.test_all()
    # TODO: There must be a better way to do this?
end

end

"""This module contains the main macros for DispatchDoctor"""
module _Macros

using .._Utils: JULIA_OK
using .._Stabilization: _stable

"""
    @stable [options...] [code_block]

A macro to enforce type stability in functions.
When applied, it ensures that the return type of the function is concrete.
If type instability is detected, a `TypeInstabilityError` is thrown.

# Options

- `default_mode::String="error"`:
  - Change the default mode from `"error"` to `"warn"` to only emit a warning, or `"disable"` to disable type instability checks by default.
  - To locally or globally override the mode for a package that uses DispatchDoctor, you can use the `"dispatch_doctor_mode"` key in your LocalPreferences.toml (typically configured with Preferences.jl).
- `default_codegen_level::String="debug"`:
  - Set the code generation level to `"min"` to only generate a single function body for each stabilized function. The default, `"debug"`, generates an entire duplicate function so that `@code_warntype` can be used.
  - To locally or globally override the code generation level for a package that uses DispatchDoctor, you can use the `"dispatch_doctor_codegen_level"` key in your LocalPreferences.toml.
- `default_union_limit::Int=1`:
  - Sets the maximum elements in a union to be considered stable. The default is `1`, meaning that all unions are considered unstable. A value of `2` would indicate that `Union{Float32,Float64}` is considered stable, but `Union{Float16,Float32,Float64}` is not.
  - To locally or globally override the union limit for a package that uses DispatchDoctor, you can use the `"dispatch_doctor_union_limit"` key in your LocalPreferences.toml.


# Example
    
```julia
using DispatchDoctor: @stable

@stable function relu(x)
    if x > 0
        return x
    else
        return 0.0
    end
end
```

which will automatically flag any type instability:

```julia
julia> relu(1.0)
1.0

julia> relu(0)
ERROR: TypeInstabilityError: Instability detected in function `relu`
with arguments `(Int64,)`. Inferred to be `Union{Float64, Int64}`,
which is not a concrete type.
```

# Extended help

You may also apply `@stable` to arbitrary blocks of code, such as `begin`
or `module`, and have it be applied to all functions.
(Just note that this skips closure functions.)

```julia
using DispatchDoctor: @stable

@stable begin
    f(x) = x
    g(x) = x > 0 ? x : 0.0
    @unstable begin
        g(x::Int) = x > 0 ? x : 0.0
    end
    module A
        h(x) = x
        include("myfile.jl")
    end
end
```

This `@stable` will apply to `f`, `g`, `h`,
as well as all functions within `myfile.jl`.
It skips the definition `g(x::Int)`, meaning
that when `Int` input is provided to `g`,
type instability is not detected.

"""
macro stable(args...)
    if JULIA_OK
        return esc(_stable(args...; source_info=__source__, calling_module=__module__))
    else
        return esc(args[end])
    end
end

"""
    @unstable [code_block]

A no-op macro to hide blocks of code from `@stable`.
"""
macro unstable(fex)
    return esc(fex)
end

end

module DispatchDoctorEnzymeCoreExt

using EnzymeCore: EnzymeRules as ER
using DispatchDoctor._RuntimeChecks: is_precompiling, checking_enabled
using DispatchDoctor._Stabilization: _show_warning, _construct_pairs
using DispatchDoctor._Utils:
    specializing_typeof,
    map_specializing_typeof,
    _promote_op,
    type_instability,
    type_instability_limit_unions

ER.inactive_noinl(::typeof(_show_warning), ::Any...) = nothing
ER.inactive_noinl(::typeof(_construct_pairs), ::Any...) = nothing

ER.inactive_noinl(::typeof(specializing_typeof), ::Any) = nothing
ER.inactive_noinl(::typeof(map_specializing_typeof), ::Any...) = nothing
ER.inactive_noinl(::typeof(_promote_op), ::Any...) = nothing
ER.inactive_noinl(::typeof(type_instability), ::Any...) = nothing
ER.inactive_noinl(::typeof(type_instability_limit_unions), ::Any...) = nothing

ER.inactive_noinl(::typeof(is_precompiling), ::Any...) = nothing
ER.inactive_noinl(::typeof(checking_enabled), ::Any...) = nothing

end

const TEST = get(ENV, "DISPATCH_DOCTOR_TEST", "unit")

@static if occursin(TEST, "unit")
    include("unittests.jl")
elseif occursin(TEST, "enzyme")
    include("enzyme.jl")
elseif occursin(TEST, "zygote")
    include("zygote.jl")
elseif occursin(TEST, "dynamic-expressions")
    include("dynamic_expressions.jl")
end

using BenchmarkTools
using DispatchDoctor: DispatchDoctor, _stable

const SUITE = BenchmarkGroup()

ex = quote
    f() = rand(Bool) ? 0 : 1.0
    f(x) = x
    module A
    function g(; a, b)
        return a + b
    end

    module B
        $(DispatchDoctor).@unstable begin
            h() = rand(Bool) ? 0 : 1.0
        end
    end
    end
end

for mode in ("error", "warn", "disable")
    options = Any[:(default_mode = $mode)]
    SUITE["_stable"]["mode=$mode"] = @benchmarkable(
        $_stable(options..., ex; calling_module=nothing, source_info=nothing),
        setup = (ex = $(QuoteNode(ex)); options = $options)
    )
end

"""This module contains functions for modifying stabilized-functions at runtime"""
module _RuntimeChecks

using .._Errors: AllowUnstableDataRace

"""To avoid errors and warnings during precompilation."""
@inline is_precompiling() = ccall(:jl_generating_output, Cint, ()) == 1

"""To locally enable/disable instability checks."""
@inline function checking_enabled()
    return !is_precompiling() && INSTABILITY_CHECK_ENABLED.value[]
end

const INSTABILITY_CHECK_ENABLED = (; value=Ref(true), lock=ReentrantLock())

"""
    allow_unstable(f::F) where {F<:Function}

Globally disable type DispatchDoctor instability checks within the provided function `f`.

This function allows you to execute a block of code where type instability
checks are disabled. It ensures that the checks are re-enabled after the block
is executed, even if an error occurs.

This function uses a `ReentrantLock` and will throw an error if used from
two tasks at once.

# Usage

```
allow_unstable() do
    # do unstable stuff
end
```

# Arguments

- `f::F`: A function to be executed with type instability checks disabled.

# Returns

- The result of the function `f`.

# Notes

You cannot call `allow_unstable` from two tasks at once. An error
will be thrown if you try to do so.
"""
@inline function allow_unstable(f::F) where {F<:Function}
    successful_lock = trylock(INSTABILITY_CHECK_ENABLED.lock)
    if !successful_lock
        throw(
            AllowUnstableDataRace(
                "You cannot call `allow_unstable` from two tasks at once. " *
                "This error is a result of `INSTABILITY_CHECK_ENABLED` " *
                "being locked by another task.",
            ),
        )
    end
    old_value = INSTABILITY_CHECK_ENABLED.value[]
    INSTABILITY_CHECK_ENABLED.value[] = false
    out = try
        f()
    finally
        INSTABILITY_CHECK_ENABLED.value[] = old_value
        unlock(INSTABILITY_CHECK_ENABLED.lock)
    end
    return out
end

end

"""This module defines the main exceptions returned by DispatchDoctor"""
module _Errors

struct AllowUnstableDataRace <: Exception
    msg::String
end

struct TypeInstabilityError <: Exception
    f::String
    source_info::Union{String,Nothing}
    args::Any
    kwargs::Any
    params::Any
    return_type::Any
end

struct TypeInstabilityWarning
    f::String
    source_info::Union{String,Nothing}
    args::Any
    kwargs::Any
    params::Any
    return_type::Any
end

end

using Pkg
using Git
using TOML

mktempdir() do tempdir
    # Clone DynamicExpressions.jl at a fixed version
    repo_url = "https://github.com/SymbolicML/DynamicExpressions.jl.git"
    dest_dir = joinpath(tempdir, "DynamicExpressions")
    run(`$(git()) clone $repo_url $dest_dir`)
    run(`$(git()) -C $dest_dir checkout v2.2.0`)

    dd_path = dirname(dirname(@__FILE__))
    dd_toml_content = TOML.parsefile(joinpath(dd_path, "Project.toml"))
    dd_version = dd_toml_content["version"]

    # Modify compat in Project.toml
    project_toml_path = joinpath(dest_dir, "Project.toml")
    toml_content = TOML.parsefile(project_toml_path)
    toml_content["compat"]["DispatchDoctor"] = "=$dd_version"
    open(project_toml_path, "w") do io
        TOML.print(io, toml_content)
    end

    # Julia 1.12 world-age workaround:
    #
    # DynamicExpressions’ `@extend_operators` defines methods via `eval` during execution.
    # When this happens inside a single top-level expression (e.g. inside a `let` block),
    # calling the newly-extended operator in the same expression can dispatch to the old
    # method due to world age. This causes the upstream tests to execute the operator body
    # instead of building a `Node`.
    chainrules_path = joinpath(dest_dir, "test", "test_chainrules.jl")
    if isfile(chainrules_path)
        s = read(chainrules_path, String)
        s = replace(s, "nan_forward = bad_op(x1 + 0.5)" => "nan_forward = Base.invokelatest(bad_op, x1 + 0.5)")
        s = replace(s, "undefined_grad = undefined_grad_op(x1 + 0.5)" => "undefined_grad = Base.invokelatest(undefined_grad_op, x1 + 0.5)")
        s = replace(s, "nan_grad = bad_grad_op(x1)" => "nan_grad = Base.invokelatest(bad_grad_op, x1)")
        write(chainrules_path, s)
    end

    # Aqua.jl piracy check currently relies on internals that changed in Julia 1.12.
    # Keep the rest of Aqua checks enabled, but disable piracy on Julia ≥ 1.12 so
    # that DynamicExpressions' test suite can run in our CI matrix.
    aqua_path = joinpath(dest_dir, "test", "test_aqua.jl")
    if isfile(aqua_path)
        s = read(aqua_path, String)
        s = replace(
            s,
            "Aqua.test_all(DynamicExpressions; project_toml_formatting=false)" =>
                "Aqua.test_all(DynamicExpressions; project_toml_formatting=false, piracy = VERSION < v\"1.12.0\")",
        )
        write(aqua_path, s)
    end

    # Activate the environment
    Pkg.activate(dest_dir)
    Pkg.develop(; path=dd_path)
    Pkg.instantiate()

    # Run upstream tests
    Pkg.test()
end

using TestItems: @testitem
using TestItemRunner

@testitem "smoke test" begin
    using DispatchDoctor
    for codegen_level in ("debug", "min")
        @eval @stable default_codegen_level = $codegen_level f(x) = x
        @test f(1) == 1
    end
end
@testitem "with error" begin
    using DispatchDoctor
    for codegen_level in ("debug", "min")
        @eval @stable default_codegen_level = $codegen_level f(x) = x > 0 ? x : 1.0
        DispatchDoctor.JULIA_OK && @test_throws TypeInstabilityError f(1)
        @test f(2.0) == 2.0
    end
end
@testitem "with kwargs" begin
    using DispatchDoctor
    for codegen_level in ("debug", "min")
        @eval @stable default_codegen_level = $codegen_level f(x; a=1, b=2) = x + a + b
        @test f(1) == 4
        @eval @stable default_codegen_level = $codegen_level g(; a=1) = a > 0 ? a : 1.0
        DispatchDoctor.JULIA_OK && @test_throws TypeInstabilityError g(a=1)
        @test g(; a=2.0) == 2.0
    end
end
@testitem "tuple args" begin
    using DispatchDoctor
    for codegen_level in ("debug", "min")
        @eval @stable default_codegen_level = $codegen_level f((x, y); a=1, b=2) =
            x + y + a + b
        @test f((1, 2)) == 6
        @test f((1, 2); b=3) == 7
        @eval @stable default_codegen_level = $codegen_level g((x, y), z=1.0; c=2.0) =
            x > 0 ? y : c + z
        @test g((1, 2.0)) == 2.0
        DispatchDoctor.JULIA_OK && @test_throws TypeInstabilityError g((1, 2))
    end
end
@testitem ":: args" begin
    using DispatchDoctor
    for codegen_level in ("debug", "min")
        @eval @stable default_codegen_level = $codegen_level f(x::Int) = x
        @test f(1) == 1
        @eval @stable default_codegen_level = $codegen_level g(; x::Int) = x
        @test g(; x=1) == 1
        @eval @stable default_codegen_level = $codegen_level h(x::Number; y::Number) =
            x > y ? x : y
        @test h(1; y=2) == 2
        DispatchDoctor.JULIA_OK && @test_throws TypeInstabilityError h(1; y=2.0)
    end
end
@testitem ":: tuple args" begin
    using DispatchDoctor

    for codegen_level in ("debug", "min")
        #! format: off
        f_expanded = @eval @macroexpand @stable(
            default_codegen_level = $codegen_level,
            function f((x,)::Vector)
                return x
            end
        )
        #! format: on

        expected_code_snippets = [
            # Original signature preserved in simulator:
            r"function var\"[#0-9]*f_simulator[#0-9]*\"\(\(x,\)::Vector[,; ]*\)$"m,
            # Gensymmed arg used in new signature:
            r"function f\(var\"[#0-9]*arg[#0-9]*\"::Vector[,; ]*\)$"m,
            # Gensymmed arg used in instability check:
            r"_promote_op.*var\"[#0-9]*arg[#0-9]*\"",
        ]

        # Destructuring assignment in body:
        codegen_level == "debug" &&
            push!(expected_code_snippets, r"\(x,\) = var\"[#0-9]*arg[#0-9]*\"$"m)

        # Simulator called with gensymmed arg
        codegen_level == "min" && push!(
            expected_code_snippets,
            r"var\"[#0-9]*f_simulator[#0-9]*\"\(var\"[#0-9]*arg[#0-9]*\"[,; ]*\)$"m,
        )

        DispatchDoctor.JULIA_OK && for expected_code in expected_code_snippets
            @test occursin(expected_code, string(f_expanded))
        end

        eval(f_expanded)

        call_f(args...) = Base.invokelatest(f, args...)

        @test call_f([1]) == 1
        @test_throws MethodError call_f((1,)) == 1
        DispatchDoctor.JULIA_OK && @test_throws TypeInstabilityError call_f(Any[1])
    end
end
@testitem "multiple tuple args" begin
    using DispatchDoctor

    for codegen_level in ("debug", "min")
        #! format: off
        @eval @stable(
            default_codegen_level = $codegen_level,
            f((x, y)::Vector) = x + y,
        )
        @eval @stable(
            default_codegen_level = $codegen_level,
            g((x, y)::Vector, (z,)) = x + y + z,
        )
        #! format: on

        @test f([1, 2]) == 3
        @test g([1, 2], (3,)) == 6

        @test_throws MethodError f((1, 2))
        @test_throws MethodError g((1, 2), (3,))

        if DispatchDoctor.JULIA_OK
            @test_throws TypeInstabilityError f(Any[1, 2])
            @test_throws TypeInstabilityError g(Any[1, 2], (3,))
        end
    end
end
@testitem "property destructuring" begin
    using DispatchDoctor

    if v"1.7-" <= VERSION  # property destructuring introduced in 1.7
        abstract type MyAbstractType end
        struct StableType <: MyAbstractType
            x::Int
            y::Float64
        end
        struct UnstableType <: MyAbstractType
            x
            y
        end
        for codegen_level in ("debug", "min")
            #! format: off
            fex = @eval @macroexpand @stable(
                default_codegen_level = $codegen_level,
                f((; x)::MyAbstractType) = x
            )
            #! format: on

            expected_code_snippets = [
                # Original signature preserved in simulator
                r"function var\"[#0-9]*f_simulator[#0-9]*\"\(\(; x\)::MyAbstractType[,; ]*\)$"m,
                # Gensymmed arg used in new signature
                r"function f\(var\"[#0-9]*arg[#0-9]*\"::MyAbstractType[,; ]*\)$"m,
                # Gensymmed arg used in instability check
                r"_promote_op.*var\"[#0-9]*arg[#0-9]*\"",
            ]
            codegen_level == "debug" &&
                push!(expected_code_snippets, r"\(; x\) = var\"[#0-9]*arg[#0-9]*\"$"m)
            codegen_level == "min" && push!(
                expected_code_snippets,
                r"var\"[#0-9]*f_simulator[#0-9]*\"\(var\"[#0-9]*arg[#0-9]*\"[,; ]*\)$"m,
            )

            DispatchDoctor.JULIA_OK && for expected_code in expected_code_snippets
                @test occursin(expected_code, string(fex))
            end

            eval(fex)

            call_f(args...) = Base.invokelatest(f, args...)

            @test call_f(StableType(1, 2.0)) == 1
            @test_throws MethodError call_f((; x=1))
            DispatchDoctor.JULIA_OK &&
                @test_throws TypeInstabilityError call_f(UnstableType(1, 2.0))
        end
    end
end
@testitem "multiple property destructuring" begin
    using DispatchDoctor

    if v"1.7-" <= VERSION  # property destructuring introduced in 1.7
        abstract type MyAbstractType2 end
        struct StableType2 <: MyAbstractType2
            x::Int
            y::Float64
        end
        struct UnstableType2 <: MyAbstractType2
            x
            y
        end
        for codegen_level in ("debug", "min")
            #! format: off
            @eval @stable(
                default_codegen_level = $codegen_level,
                f((; x, y)::MyAbstractType2) = x + y,
            )
            @eval @stable(
                default_codegen_level = $codegen_level,
                g((; x, y)::MyAbstractType2, (; z)) = x + y + z,
            )
            @eval @stable(
                default_codegen_level = $codegen_level,
                h((a, b)::Vector, (; x, y)::MyAbstractType2) = a + b + x + y,
            )
            @eval @stable(
                default_codegen_level = $codegen_level,
                k(a, (; x, y)=(; z=1, x=a, y=3)) = x + y,
            )
            #! format: on

            @test f(StableType2(1, 2.0)) == 3.0
            @test g(StableType2(1, 2.0), (; z=3)) == 6.0
            @test h([3, 4], StableType2(1, 2.0)) == 10.0
            @test k(1) == 4
            @test k(nothing, StableType2(1, 2.0)) == 3.0

            @test_throws MethodError f((; x=1, y=2.0))
            @test_throws MethodError g((; x=1, y=2.0), (; z=3))
            @test_throws MethodError h([3, 4], (; x=1, y=2.0))
            @test_throws MethodError h((3, 4), StableType2(1, 2.0))

            if DispatchDoctor.JULIA_OK
                @test_throws TypeInstabilityError f(UnstableType2(1, 2.0))
                @test_throws TypeInstabilityError g(UnstableType2(1, 2.0), (; z=3))
                @test_throws TypeInstabilityError h([3, 4], UnstableType2(1, 2.0))
                @test_throws TypeInstabilityError h(Any[3, 4], UnstableType2(1, 2.0))
                @test_throws TypeInstabilityError k(nothing, UnstableType2(1, 2.0))
            end
        end
    end
end
@testitem "detect duplicate LineNumberNode in @stable expansion" begin
    using DispatchDoctor

    # Basically we want to verify that the simulator function
    # doesn't duplicate any LineNumberNodes, which can
    # mess with stacktraces and coverage.
    ex = @macroexpand(@stable(function f(x)
        return x
    end))

    function collect_line_nodes!(line_nodes, expr)
        if expr isa LineNumberNode
            push!(line_nodes, expr)
        elseif expr isa Expr
            for arg in expr.args
                collect_line_nodes!(line_nodes, arg)
            end
        end
        return line_nodes
    end

    line_nodes = collect_line_nodes!([], ex)

    @test length(line_nodes) > 1
    @test length(unique(line_nodes)) == length(line_nodes)  # No dupes!
end
@testitem "Type specialization" begin
    using DispatchDoctor
    for codegen_level in ("debug", "min")
        @eval @stable default_codegen_level = $codegen_level f(a, ::Type{T}) where {T} =
            sum(a; init=zero(T))
        @test f([1.0f0, 1.0f0], Float32) == 2.0f0
    end
end
@testitem "args and kwargs" begin
    using DispatchDoctor
    for codegen_level in ("debug", "min")
        # Without the dots
        @eval @stable default_codegen_level = $codegen_level f1(a, args::Vararg) =
            sum(args) + a
        @test f1(1, 1, 2, 3) == 7

        # Without the dots, with curly on Vararg
        @eval @stable default_codegen_level = $codegen_level f1(
            a, args::Vararg{Any,M}
        ) where {M} = sum(args) + a
        @test f1(1, 1, 2, 3) == 7

        # With the dots
        @eval @stable default_codegen_level = $codegen_level f2(a, args...) = sum(args) + a
        @test f2(1, 1, 2, 3) == 7

        # With kwargs
        @eval @stable default_codegen_level = $codegen_level f3(c; kwargs...) =
            sum(values(kwargs)) + c
        @test f3(1; a=1, b=2, c=3) == 7

        # With both
        @eval @stable default_codegen_level = $codegen_level f4(a, args...; d, kwargs...) =
            sum(args) + sum(values(kwargs)) + a + d
        @test f4(1, 1, 2, 3; d=0, a=1, b=2, c=3) == sum((1, 1, 2, 3, 0, 1, 2, 3))
    end
end
@testitem "string macro" begin
    using DispatchDoctor

    @test @stable(v"1.10.0") == v"1.10.0"
end
@testitem "complex arg without symbol" begin
    using DispatchDoctor: DispatchDoctor as DD
    struct Undefined end
    for codegen_level in ("debug", "min")
        @eval @stable default_codegen_level = $codegen_level function f(
            ::Type{T1}=Undefined
        ) where {T1}
            return T1
        end
        @test f() == Undefined
    end
end
@testitem "vararg with type" begin
    using DispatchDoctor
    for codegen_level in ("debug", "min")
        @eval @stable default_codegen_level = $codegen_level function f(::Int...)
            return rand(Bool) ? 0 : 0.0
        end
        DispatchDoctor.JULIA_OK && @test_throws TypeInstabilityError f(1, 2, 3)

        @eval @stable default_codegen_level = $codegen_level function f2(a::Int...)
            return rand(Bool) ? 0 : 0.0
        end
        DispatchDoctor.JULIA_OK && @test_throws TypeInstabilityError f2(1, 2, 3)

        @eval @stable default_codegen_level = $codegen_level function f3(a, ::Int...)
            return rand(Bool) ? 0 : 0.0
        end
        DispatchDoctor.JULIA_OK && @test_throws TypeInstabilityError f3(1, 2, 3)

        # With expression-based type
        @eval @stable default_codegen_level = $codegen_level function g(::typeof(*)...)
            return rand(Bool) ? 0 : 0.0
        end
        DispatchDoctor.JULIA_OK && @test_throws TypeInstabilityError g(*, *)
    end
end
@testitem "QuoteNode in options" begin
    using DispatchDoctor
    using DispatchDoctor: _ParseOptions as DDPO
    default_mode = "disable"
    @eval @stable default_mode = $default_mode f() = Val(rand())
    @test f() isa Val
    @test DDPO._parse(QuoteNode(default_mode), String) == "disable"

    # Edge case
    @test DDPO._parse(nothing, String) == nothing
end
@testitem "showerror" begin
    using DispatchDoctor

    # no args or kwargs
    @stable f1() = rand() > 0 ? 1.0 : 0

    # only args:
    @stable f2(x) = x > 0 ? x : 0.0

    # only kwargs:
    @stable f3(; a) = a > 0 ? a : 0.0

    # args and kwargs:
    @stable f4(x; a) = x > 0 ? x : a

    # Stable calls:
    @test f2(1.0) == 1.0
    @test f3(; a=1.0) == 1.0
    @test f4(2.0; a=1.0) == 2.0
    if DispatchDoctor.JULIA_OK
        @test_throws TypeInstabilityError f1()
        @test_throws TypeInstabilityError f2(0)
        @test_throws TypeInstabilityError f3(a=0)
        @test_throws TypeInstabilityError f4(0; a=0.0)

        @test_throws(
            "Inferred to be `Union{Float64, Int64}`, which is not a concrete type.", f1()
        )
        @test_throws(
            "with arguments `(Int64,)`. Inferred to be `Union{Float64, Int64}`, which is not a concrete type.",
            f2(0)
        )

        @test_throws(
            "TypeInstabilityError: Instability detected in `f4` defined at ", f4(0; a=0.0)
        )
        if VERSION >= v"1.10.0-DEV.0"
            @test_throws(
                "with keyword arguments `@NamedTuple{a::Int64}`. Inferred to be `Union{Float64, Int64}`, which is not a concrete type.",
                f3(a=0)
            )
            @test_throws(
                "with arguments `(Int64,)` and keyword arguments `@NamedTuple{a::Float64}`. Inferred to be `Union{Float64, Int64}`, which is not a concrete type.",
                f4(0; a=0.0)
            )
        end
    end
end
@testitem "Test forwarding documentation" begin
    using DispatchDoctor

    """Docs for my function."""
    function f1(x)
        return x
    end

    """Docs for my stable function."""
    @stable function f2(x)
        return x
    end

    # TODO: Julia 1.11's @doc acting weird so we skip it
    if VERSION < v"1.11.0-DEV.0"
        @test strip(string(@doc(f1))) == "Docs for my function."
        @test strip(string(@doc(f2))) == "Docs for my stable function."
    end
end
@testitem "Signature without symbol" begin
    using DispatchDoctor
    @stable f(x, ::Type{T}) where {T} = rand(Bool) ? T : Float64
    DispatchDoctor.JULIA_OK && @test_throws TypeInstabilityError f(1.0, Float32)
    if VERSION >= v"1.9"
        @test_throws("Instability detected in `f` defined at", f(1.0, Float32))
        @test_throws(
            "with arguments `(Float64, Type{Float32})` and parameters `(:T => Float32,)`.",
            f(1.0, Float32)
        )
    end
end
@testitem "showing whereparams" begin
    using DispatchDoctor
    @stable f(::Type{T}, ::A) where {T,G,A<:AbstractArray{G}} =
        rand(Bool) ? Float32 : Float64

    DispatchDoctor.JULIA_OK && @test_throws TypeInstabilityError f(Int, [1.0, 2.0])
    if VERSION >= v"1.9"
        @test_throws "and parameters `(:T => Int64, :G => Float64, :A => Vector{Float64})`" f(
            Int, [1.0, 2.0]
        )
    end
end
@testitem "skip parameterized functions" begin
    using DispatchDoctor
    struct MyType{T} end
    @stable function MyType{T}() where {T}
        return rand(Bool) ? T : one(T)
    end
    @test MyType{Int}() in (Int, 1)
end
@testitem "skip expression-based function names" begin
    using DispatchDoctor
    using MacroTools: splitdef, @expand
    abstract type AbstractMyType{T} end
    struct MyType2{T} <: AbstractMyType{T} end
    @stable function (::Type{A})() where {A<:AbstractMyType}
        return rand(Bool) ? "blah" : 1
    end
    @test MyType2() in ("blah", 1)
end
@testitem "modules" begin
    using DispatchDoctor
    @stable module Amodules
    f1(x) = x
    f2(; a=1) = a > 0 ? a : 0.0
    function f3()
        return rand(Bool) ? 0.0 : 1
    end
    end

    @test Amodules.f1(1) == 1
    @test Amodules.f2(; a=1.0) == 1.0
    DispatchDoctor.JULIA_OK && @test_throws TypeInstabilityError Amodules.f2(a=1)
    DispatchDoctor.JULIA_OK && @test_throws TypeInstabilityError Amodules.f3()
end
@testitem "single-line module" begin
    using DispatchDoctor
    @stable module Asingleline
    f(x) = x > 0 ? x : 0.0
    end

    @test Asingleline.f(1.0) == 1.0
    DispatchDoctor.JULIA_OK && @test_throws TypeInstabilityError Asingleline.f(1)
end
@testitem "module with include" begin
    using DispatchDoctor
    (path, io) = mktemp()
    println(io, "f(x) = x > 0 ? x : 0.0")
    close(io)

    @eval @stable module Amodulewithinclude
    include($path)
    end

    @test Amodulewithinclude.f(1.0) == 1.0
    DispatchDoctor.JULIA_OK && @test_throws TypeInstabilityError Amodulewithinclude.f(1)
end
@testitem "nested modules with include" begin
    using DispatchDoctor
    (path, io) = mktemp()
    println(io, "f(x) = x > 0 ? x : 0.0")
    close(io)

    #! format: off
    @eval @stable module Anestedmoduleswithinclude
        module B
            include($path)
            h(x) = x > 0 ? x : 0.0
        end
    end
    #! format: on

    @test Anestedmoduleswithinclude.B.f(1.0) == 1.0
    @test Anestedmoduleswithinclude.B.h(1.0) == 1.0
    DispatchDoctor.JULIA_OK &&
        @test_throws TypeInstabilityError Anestedmoduleswithinclude.B.f(1)
    DispatchDoctor.JULIA_OK &&
        @test_throws TypeInstabilityError Anestedmoduleswithinclude.B.h(1)
end
@testitem "closures not wrapped in module version" begin
    using DispatchDoctor: @stable
    @stable module Aclosuresunwrapped
    function f(x)
        closure() = rand(Bool) ? 0 : 1.0
        print(devnull, closure())
        return x
    end
    end

    # If it wrapped the closure, this would have thrown an error!
    @test Aclosuresunwrapped.f(1) == 1
end
@testitem "avoid double stable in module" begin
    using DispatchDoctor: _stabilize_module
    using MacroTools: postwalk, @capture

    ex = first(
        _stabilize_module(
            :(module Aavoiddouble
            using DispatchDoctor: @stable

            @stable f(x) = x > 0 ? x : 0.0
            g(x, y) = x > 0 ? y : 0.0
            end),
            DispatchDoctor._Stabilization.DownwardMetadata(),
        ),
    )

    # First, we capture `f` using postwalk and `@capture`
    f_defs = []
    #! format: off
    postwalk(ex) do ex_part
        if @capture(ex_part, (f_(args__) = body_) | (function f_(args__) body_ end))
            push!(f_defs, ex_part)
        end
        ex_part
    end
    #! format: on

    # We should be able to find a g_simulator, but NOT
    # an f_simulator (indicating the `@stable` has
    # not been expanded yet)
    @test length(f_defs) == 3

    @test any(e -> occursin("g_simulator", string(e)), f_defs)
    @test !any(e -> occursin("f_simulator", string(e)), f_defs)

    eval(ex)

    @test Aavoiddouble.f(1.0) == 1.0
    @test Aavoiddouble.g(1.0, 0.0) == 0.0
    DispatchDoctor.JULIA_OK && @test_throws TypeInstabilityError Aavoiddouble.f(0)
    DispatchDoctor.JULIA_OK && @test_throws TypeInstabilityError Aavoiddouble.g(1.0, 0)
end
@testitem "allow unstable within module" begin
    using DispatchDoctor

    @stable module Aallowunstable
    using DispatchDoctor: @unstable

    g() = f()
    @unstable f() = rand(Bool) ? 0 : 1.0
    end

    @test Aallowunstable.f() in (0, 1.0)
    DispatchDoctor.JULIA_OK && @test_throws TypeInstabilityError Aallowunstable.g()
end
@testitem "anonymous functions" begin
    using DispatchDoctor
    using DispatchDoctor: _stabilize_fnc

    @stable f = () -> rand(Bool) ? Float32 : Float64
    DispatchDoctor.JULIA_OK && @test_throws TypeInstabilityError f()
    if VERSION >= v"1.9"
        @test_throws " anonymous function defined at " f()
    end
end
@testitem "skip empty functions" begin
    using DispatchDoctor: _stabilize_fnc, _stabilize_all

    ex = _stabilize_all(
        :(function donothing end), DispatchDoctor._Stabilization.DownwardMetadata()
    )[1]
    @test ex == :(function donothing end)

    # TODO: Fragile test of MacroTools internals
    @test_throws AssertionError _stabilize_fnc(
        :(function donothing end), DispatchDoctor._Stabilization.DownwardMetadata()
    )
end
@testitem "underscore argument" begin
    using DispatchDoctor
    @stable f(_) = rand(Bool) ? Float32 : Float64
    DispatchDoctor.JULIA_OK && @test_throws TypeInstabilityError f(1)
    if VERSION >= v"1.9"
        @test_throws "with arguments `(Int64,)`" f(1)
    end
end
@testitem "skip closures inside macros" begin
    using DispatchDoctor: DispatchDoctor as DD

    stabilized = DD._stabilize_all(
        :(macro m(ex)
            f() = rand(Bool) ? Float32 : Float64
            f()
            return ex
        end),
        DispatchDoctor._Stabilization.DownwardMetadata(),
    )

    # Should skip the internal function
    @test !occursin("f_closure", string(stabilized))
end
@testitem "skip quoted code" begin
    using DispatchDoctor
    @stable eval(
        quote
            function f(x)
                return rand(Bool) ? 1 : 1.0
            end
        end,
    )
    @test f(1) == 1
end
@testitem "warnings" begin
    using DispatchDoctor
    using Suppressor: @capture_err
    #! format: off
    @stable default_mode="warn" function f(x)
        x > 0 ? x : 0.0
    end
    #! format: on

    if DispatchDoctor.JULIA_OK
        msg = @capture_err f(1)
        @test occursin("DispatchDoctor.TypeInstabilityWarning", msg)
    end
end
@testitem "disable @stable using env variable" begin
    using DispatchDoctor
    ENV["__DISPATCH_DOCTOR_TESTING_VAR"] = "disable"

    @stable default_mode = ENV["__DISPATCH_DOCTOR_TESTING_VAR"] function f(x)
        return rand(Bool) ? 1 : 1.0
    end

    @test f(1) == 1
end
@testitem "bad macro option" begin
    using DispatchDoctor
    if DispatchDoctor.JULIA_OK
        @test_throws(LoadError, @eval @stable badoption = true f(x) = x^2)
        @test_throws("Unknown macro option", @eval @stable badoption = true f(x) = x^2)
    end
end
@testitem "bad choice of mode" begin
    using DispatchDoctor
    if DispatchDoctor.JULIA_OK
        @test_throws(LoadError, @eval @stable default_mode = "bad" f(x) = x^2)
        @test_throws("Unknown mode", @eval @stable default_mode = "bad" f(x) = x^2)
    end
end
@testitem "bad choice of codegen level" begin
    using DispatchDoctor
    if DispatchDoctor.JULIA_OK
        @test_throws(LoadError, @eval @stable default_codegen_level = "bad" f(x) = x^2)
        @test_throws(
            "Unknown codegen level", @eval @stable default_codegen_level = "bad" f(x) = x^2
        )
    end
end
@testitem "allow errors through" begin
    using DispatchDoctor

    @stable my_bad_function(x) = x / "blah"

    @test_throws MethodError my_bad_function(1)
end
@testitem "dont flag Type{T} as not concrete" begin
    using DispatchDoctor

    @stable function f(t)
        return t
    end

    @test f(Float32) == Float32

    @test !Base.isconcretetype(Type{Float32})

    # We have a special method to fix this:
    @test !DispatchDoctor.type_instability(Type{Float32})

    # Will work recursively
    @test !DispatchDoctor.type_instability(Type{Type{Float32}})
end
@testitem "begin block" begin
    using DispatchDoctor

    @stable begin
        f(x) = x > 0 ? x : 0.0
        g(x) = x > 0 ? x : 0.0
    end

    @test f(1.0) == 1.0
    @test g(1.0) == 1.0
    DispatchDoctor.JULIA_OK && @test_throws TypeInstabilityError f(1)
    DispatchDoctor.JULIA_OK && @test_throws TypeInstabilityError g(1)
end
@testitem "include within begin" begin
    using DispatchDoctor
    using Suppressor: @capture_err

    (path, io) = mktemp()
    println(io, "f(x) = x > 0 ? x : 0.0")
    close(io)

    msg = @capture_err @eval @stable begin
        include(path)
    end

    @test f(1.0) == 1.0
    DispatchDoctor.JULIA_OK && @test_throws TypeInstabilityError f(1)

    @test !occursin("`@stable` found no compatible functions to stabilize", msg)
end
@testitem "stabilizing a class instantiation" begin
    using DispatchDoctor: DispatchDoctor as DD

    struct MyStruct
        x::Number
    end

    # (There used to be an issue because the func[:name] is not a symbol)
    @stable (::Type{MyStruct})() = MyStruct(1)
    @test MyStruct() == MyStruct(1)
end
@testitem "allow unstable" begin
    using DispatchDoctor
    @stable f() = rand(Bool) ? 1 : 1.0
    DispatchDoctor.JULIA_OK && @test_throws TypeInstabilityError f()
    @test allow_unstable(f) == 1

    # Should maintain type stability if not present
    @inferred allow_unstable(@stable () -> 1.0)
end
@testitem "allow unstable preserves stability" begin
    using DispatchDoctor
    f(x) = sum(x)
    g(x) = allow_unstable(() -> f(x))
    @inferred g([1, 2, 3])
    @test g([1, 2, 3]) == 6
end
@testitem "allow unstable with error" begin
    using DispatchDoctor
    @stable f() = 1 / "blah"
    @test_throws MethodError f()
    @test_throws MethodError allow_unstable(f)

    # Should be safely turned back on, despite the early exit
    @test DispatchDoctor.INSTABILITY_CHECK_ENABLED.value[] == true
end
@testitem "nested allow unstable" begin
    using DispatchDoctor
    @stable f() = rand(Bool) ? 1 : 1.0
    g() = allow_unstable(f)
    h() = allow_unstable(g)
    DispatchDoctor.JULIA_OK && @test_throws TypeInstabilityError f()
    @test g() == 1
    # Because we use a reentrant lock, nested
    # calls are allowed:
    @test h() == 1
end
@testitem "error on multiple tasks" begin
    using DispatchDoctor: DispatchDoctor as DD
    host_channel = Channel()
    task_channel = Channel()
    if islocked(DD.INSTABILITY_CHECK_ENABLED.lock)
        error("Can't run this test in parallel.")
    end
    t = @async begin
        try
            lock(DD.INSTABILITY_CHECK_ENABLED.lock)
            put!(task_channel, 1)
            take!(host_channel)
        finally
            unlock(DD.INSTABILITY_CHECK_ENABLED.lock)
            put!(task_channel, 1)
        end
    end
    take!(task_channel)    # now locked
    @test_throws DD.AllowUnstableDataRace DD.allow_unstable(() -> 1)
    if VERSION >= v"1.9"
        @test_throws "You cannot call `allow_unstable` from two tasks at once" DD.allow_unstable(
            () -> 1
        )
    end
    put!(host_channel, 1)  # ready for exit
    take!(task_channel)    # now unlocked
    @test DD.allow_unstable(() -> 1) == 1
end
@testitem "closures preventing specialization" begin
    using DispatchDoctor
    @stable function g(n)
        n = Int(n)::Int
        return n
    end
    @test g(1) == 1
end
@testitem "detect closure-induced instability" begin
    using DispatchDoctor
    @stable function f(x)
        function inner()
            x = x^2
            return x
        end
        return inner()
    end
    DispatchDoctor.JULIA_OK && @test_throws TypeInstabilityError f(1)
end
@testitem "compat with simple expression-based function names" begin
    using DispatchDoctor
    using MacroTools: @expand, splitdef
    MyType = gensym()
    @eval struct $MyType end
    @eval @stable function Base.count(x::$MyType)
        return rand(Bool) ? 1 : 1.0
    end
    DispatchDoctor.JULIA_OK && @eval @test_throws TypeInstabilityError Base.count($MyType())
    @eval @stable function Base.:+(x::$MyType, y::$MyType)
        return rand(Bool) ? 1 : 1.0
    end
    DispatchDoctor.JULIA_OK && @eval @test_throws TypeInstabilityError $MyType() + $MyType()
end
@testitem "skip generated" begin
    using DispatchDoctor

    @stable @generated function f(x)
        return :(rand(Bool) ? x : 0.0)
    end
    @test f(0) == 0
end
@testitem "propagate macros" begin
    using DispatchDoctor: _stabilize_all, JULIA_OK
    ex = _stabilize_all(
        :(Base.@propagate_inbounds function f(x)
            return x > 0 ? x : 0.0
        end),
        DispatchDoctor._Stabilization.DownwardMetadata(),
    )
    JULIA_OK && @test occursin("propagate_inbounds", string(ex))
end
@testitem "register custom macros" begin
    using DispatchDoctor

    macro mymacro(ex)
        return esc(ex)
    end
    if !haskey(DispatchDoctor.MACRO_BEHAVIOR.table, Symbol("@mymacro"))
        register_macro!(Symbol("@mymacro"), DispatchDoctor.IncompatibleMacro)
    end
    @test DispatchDoctor.get_macro_behavior(:(@mymacro x = 1)) ==
        DispatchDoctor.IncompatibleMacro

    # Trying to register again should fail with a useful error
    if VERSION >= v"1.9"
        @test_throws "Macro `@mymacro` already registered" register_macro!(
            Symbol("@mymacro"), DispatchDoctor.IncompatibleMacro
        )
    end

    if DispatchDoctor.JULIA_OK
        @eval @stable @mymacro function f(x)
            return x > 0 ? x : 0.0
        end
        @test f(0) == 0
    end
end
@testitem "merging behavior of registered macros" begin
    using DispatchDoctor
    using DispatchDoctor: _Interactions as DDI

    macro compatiblemacro(ex, option)
        return esc(ex)
    end
    macro incompatiblemacro(ex)
        return esc(ex)
    end
    macro dontpropagatemacro(ex)
        return esc(ex)
    end
    if !haskey(DDI.MACRO_BEHAVIOR.table, Symbol("@compatiblemacro"))
        register_macro!(Symbol("@compatiblemacro"), DDI.CompatibleMacro)
    end
    if !haskey(DDI.MACRO_BEHAVIOR.table, Symbol("@incompatiblemacro"))
        register_macro!(Symbol("@incompatiblemacro"), DDI.IncompatibleMacro)
    end
    if !haskey(DDI.MACRO_BEHAVIOR.table, Symbol("@dontpropagatemacro"))
        register_macro!(Symbol("@dontpropagatemacro"), DDI.DontPropagateMacro)
    end
    @test DDI.get_macro_behavior(:(@compatiblemacro true x = 1)) == DDI.CompatibleMacro
    @test DDI.get_macro_behavior(:(@incompatiblemacro x = 1)) == DDI.IncompatibleMacro
    @test DDI.get_macro_behavior(:(@dontpropagatemacro x = 1)) == DDI.DontPropagateMacro

    @test DDI.combine_behavior(DDI.CompatibleMacro, DDI.CompatibleMacro) ==
        DDI.CompatibleMacro
    @test DDI.combine_behavior(DDI.CompatibleMacro, DDI.IncompatibleMacro) ==
        DDI.IncompatibleMacro
    @test DDI.combine_behavior(DDI.CompatibleMacro, DDI.DontPropagateMacro) ==
        DDI.DontPropagateMacro
    @test DDI.combine_behavior(DDI.IncompatibleMacro, DDI.CompatibleMacro) ==
        DDI.IncompatibleMacro
    @test DDI.combine_behavior(DDI.IncompatibleMacro, DDI.IncompatibleMacro) ==
        DDI.IncompatibleMacro
    @test DDI.combine_behavior(DDI.IncompatibleMacro, DDI.DontPropagateMacro) ==
        DDI.IncompatibleMacro
    @test DDI.combine_behavior(DDI.DontPropagateMacro, DDI.CompatibleMacro) ==
        DDI.DontPropagateMacro
    @test DDI.combine_behavior(DDI.DontPropagateMacro, DDI.IncompatibleMacro) ==
        DDI.IncompatibleMacro
    @test DDI.combine_behavior(DDI.DontPropagateMacro, DDI.DontPropagateMacro) ==
        DDI.DontPropagateMacro

    ex = quote
        @compatiblemacro(
            false,
            @dontpropagatemacro(
                @dontpropagatemacro(
                    @compatiblemacro(
                        @incompatiblemacro(true),
                        @dontpropagatemacro(komodo(x) = x)  # Will only take last arg
                    )
                )
            )
        )
    end
    if DispatchDoctor.JULIA_OK
        new_ex, upward_metadata = DispatchDoctor._stabilize_all(
            ex, DispatchDoctor._Stabilization.DownwardMetadata()
        )
        # We should expect:
        #   1. All of the `@dontpropagatemacro`'s to be on the outside of the block.
        #   2. The `@compatiblemacro`'s to be duplicated on both the simulator function,
        #      as well as the regular function.
        #   3. The `@incompatiblemacro` will be unaffected, as it is operating on
        #      the first argument of a multi-arg macro.
        # Note that this changes the order of the macros.
        s = replace(string(new_ex), "\n" => "")
        @test count("@dontpropagatemacro", s) == 3
        @test count("@compatiblemacro", s) == 4
        @test count("@incompatiblemacro", s) == 2

        # We test the exact sequence of macros
        outer = r"@dontpropagatemacro.*@dontpropagatemacro.*@dontpropagatemacro.*begin"
        function_def = r"@compatiblemacro.*false.*@compatiblemacro.*@incompatiblemacro.*true.*komodo"
        simulator = function_def * r"_simulator.*end"

        @test occursin(outer * r".*" * simulator * r".*" * function_def, s)
    end
end
@testitem "stack multiple complex macros" begin
    using DispatchDoctor
    using MacroTools

    macro mymacro1(ex)
        return esc(ex)
    end
    macro mymacro2(ex)
        return esc(ex)
    end
    macro mymacro3(option1, option2, ex)
        return esc(ex)
    end

    l = LineNumberNode(1, @__FILE__)
    downward_metadata = DispatchDoctor._Stabilization.DownwardMetadata(;
        macros_to_use=[[Symbol("@mymacro4"), l]], macro_keys=[gensym()]
    )
    ex, upward_metadata = DispatchDoctor._stabilize_all(
        :(@mymacro3 true false @mymacro2 @mymacro1 function foobar(x)
            return x > 0 ? x : 0.0
        end),
        downward_metadata,
    )
    @test upward_metadata.matching_function
    @test isempty(upward_metadata.unused_macros)
    @test isempty(upward_metadata.macro_keys)

    s = string(ex)
    s = replace(s, "\n" => "")

    # Applied once to the simulator:
    @test occursin(
        r"@mymacro4.*@mymacro3\(true, false.*@mymacro2.*@mymacro1.*foobar_simulator", s
    )

    # And again to the regular foobar, with the docs added:
    @test occursin(
        r"foobar_simulator.*\(Base\).@__doc__.*.*@mymacro4.*@mymacro3\(true, false.*@mymacro2.*@mymacro1.*foobar",
        s,
    )
end
@testitem "multiple macro chaining takes least compatible" begin
    using DispatchDoctor
    @stable @inline @generated function f(x)
        return :(x > 0 ? x : 0.0)
    end
    @test f(0) == 0
end
@testitem "skip assume effects" begin
    using DispatchDoctor
    if DispatchDoctor.JULIA_OK && VERSION >= v"1.8.0-DEV.0"
        @eval begin
            @stable Base.@assume_effects :nothrow function f(x)
                return x > 0 ? x : 0.0
            end
            @test f(0) == 0
        end
    end
end
@testitem "skip certain functions" begin
    using DispatchDoctor
    using DispatchDoctor: _Interactions as DDI

    @test DDI.ignore_function(+) == false
    @test DDI.ignore_function(iterate) == true

    struct MyTypeIterate end
    @stable begin
        f() = Val(rand())
        Base.iterate(::MyTypeIterate) = Val(rand())
        Base.getproperty(::MyTypeIterate, ::Symbol) = Val(rand())
        Base.setproperty!(::MyTypeIterate, ::Symbol, _) = Val(rand())
    end
    if DispatchDoctor.JULIA_OK
        @test_throws TypeInstabilityError f()
        @test iterate(MyTypeIterate()) isa Val
        @test getproperty(MyTypeIterate(), :x) isa Val
        @test setproperty!(MyTypeIterate(), :x, 1) isa Val
    end
end
@testitem "conditionally allow union instabilities" begin
    using DispatchDoctor
    @stable default_union_limit = 2 begin
        # Just a union:
        f(x) = x > 0 ? x : 0.0
        # Full-blown type instability:
        g() = Val(rand())
    end
    @test f(0) == 0
    DispatchDoctor.JULIA_OK && @test_throws TypeInstabilityError g()
end
@testitem "disallow union if any element is unstable" begin
    using DispatchDoctor
    @stable default_union_limit = 2 function f(x)
        return x > 0 ? Val(rand()) : x
    end
    # This should still fail because one of the elements is unstable!
    DispatchDoctor.JULIA_OK && @test_throws TypeInstabilityError f(0)
end
@testitem "unionall within union" begin
    using DispatchDoctor
    @stable default_union_limit = 2 function f(x)
        return [x > 0 ? Val(rand()) : x]
    end
    DispatchDoctor.JULIA_OK && @test_throws TypeInstabilityError f(0)
end
@testitem "larger union limit" begin
    using DispatchDoctor

    # Breaks with 4 unions:
    @stable default_union_limit = 3 function f(x)
        x = Union{Float16,Float32,Float64,BigFloat}[
            one(Float16), one(Float32), one(Float64), one(BigFloat)
        ]
        return x[rand(1:4)]
    end
    DispatchDoctor.JULIA_OK && @test_throws TypeInstabilityError f(0)

    # But, now it works:
    @stable default_union_limit = 4 function f(x)
        x = Union{Float16,Float32,Float64,BigFloat}[
            one(Float16), one(Float32), one(Float64), one(BigFloat)
        ]
        return x[rand(1:4)]
    end
    @test f(0) == 1
end
@testitem "union limit respects tuple" begin
    import DispatchDoctor as DD

    U2 = Union{Float32,Float64}
    U3 = Union{Float16,U2}
    @test DD.type_instability(U2) == true
    @test DD.type_instability_limit_unions(U2, Val(2)) == false
    # Limit will also apply to tuples:
    @test DD.type_instability(Tuple{U2,Bool}) == true
    @test DD.type_instability_limit_unions(Tuple{U2,Bool}, Val(2)) == false

    # Multiple unions – only max union split taken:
    @test DD.type_instability_limit_unions(Tuple{U2,U2,Bool}, Val(2)) == false
    @test DD.type_instability_limit_unions(Tuple{U2,U2,Bool}, Val(2)) == false
    @test DD.type_instability_limit_unions(Tuple{U2,U3,Bool}, Val(2)) == true

    # TypeVar should still be unstable
    @test DD.type_instability_limit_unions(Tuple{U2,T} where {T}, Val(2)) == true
end
@testitem "skip global" begin
    using DispatchDoctor
    @stable struct A
        x::Int

        global _A(x::Int) = new(x)
    end
    @test _A(1).x == 1
end
@testitem "step over docstring" begin
    using DispatchDoctor

    @stable module A
    """blah"""
    f() = rand(Bool) ? 1 : 1.0
    end

    DispatchDoctor.JULIA_OK && @test_throws TypeInstabilityError A.f()
end
@testitem "code_warntype compat" begin
    using DispatchDoctor
    using InteractiveUtils: code_warntype
    # if we use `default_codegen_level="min"`, this won't work!
    for codegen_level in ("debug", "min")
        @eval @stable default_codegen_level = $codegen_level function f(x)
            y = Tuple(x)
            return sum(y[1:2])
        end
        @test f([1, 2, 3]) == 3
        msg = sprint(code_warntype, f, typeof(([1, 2, 3],)))
        msg = lowercase(msg)
        if DispatchDoctor.JULIA_OK
            if codegen_level == "min"
                @test !occursin("tuple{vararg{int64}}", msg)
            else
                # No longer has the body!
                @test occursin("tuple{vararg{int64}}", msg)
            end
        end
    end
end
@testitem "Preferences.jl" begin
    using DispatchDoctor
    import DispatchDoctor._Preferences as DDP
    import DispatchDoctor._ParseOptions as DDPO
    import Preferences: set_preferences!, load_preference, has_preference, get_uuid

    push!(LOAD_PATH, joinpath(@__DIR__, "FakePackage1"))
    push!(LOAD_PATH, joinpath(@__DIR__, "FakePackage2"))
    push!(LOAD_PATH, joinpath(@__DIR__, "FakePackage3"))

    # These packages have `LocalPreferences.toml` with
    # various settings
    using FakePackage1

    options = DDP.StabilizationOptions("d", "e", 6)
    @test DDP.get_all_preferred(options, FakePackage1) ==
        DDP.StabilizationOptions("a", "b", 3)

    using FakePackage2
    options = DDP.StabilizationOptions("d", "e", 6)
    @test DDP.get_all_preferred(options, FakePackage2) ==
        DDP.StabilizationOptions("d", "alpha", 6)

    # FakePackage3 has no preferences
    using FakePackage3
    FakePackage3.eval(:($(DispatchDoctor).@stable f() = Val(rand())))
    if DispatchDoctor.JULIA_OK
        @test_throws TypeInstabilityError FakePackage3.f()
    end

    # By default, passing Main will just return all the options:
    @test DDPO.parse_options(Any[], Main) == DDP.StabilizationOptions(
        DDP.GLOBAL_DEFAULT_MODE,
        DDP.GLOBAL_DEFAULT_CODEGEN_LEVEL,
        DDP.GLOBAL_DEFAULT_UNION_LIMIT,
    )
end
@testitem "warn on no matches" begin
    using DispatchDoctor
    using Suppressor: @capture_err
    if DispatchDoctor.JULIA_OK
        msg = @capture_err @eval @stable @generated function f(x)
            return :(x)
        end

        @test occursin("`@stable` found no compatible functions to stabilize", msg)
        @test occursin("source_info =", msg)
        @test occursin("calling_module =", msg)
    end
end
@testitem "issue #64" begin
    using DispatchDoctor

    @stable default_union_limit = 2 function f(x)
        return x > 0 ? (nothing, 1) : (1.0, 1)
    end

    @test f(2) == (nothing, 1)
end
@testitem "issue with underscore function and min codegen" begin
    #! format: off
    using DispatchDoctor

    @stable g_debug(_::Int) = 1
    @test g_debug(1) == 1
    @stable default_codegen_level = "min" g_min(_::Int) = 1
    @test g_min(1) == 1

    @stable f_debug(_::Int, _::Float64) = 1
    @test f_debug(1, 2.0) == 1
    @stable default_codegen_level = "min" f_min(_::Int, _::Float64) = 1
    @test f_min(1, 2.0) == 1

    @stable default_codegen_level = "min" f_min_with_error(_::Int, _::Float64) = Val(rand())
    if DispatchDoctor.JULIA_OK
        @test_throws TypeInstabilityError f_min_with_error(1, 2.0)
    end
    # ! format: on
end
@testitem "deprecated options" begin
    using DispatchDoctor
    using Suppressor: @capture_err
    if DispatchDoctor.JULIA_OK
        msg = @capture_err @eval @stable warnonly = true enable = true function f(x)
            return x > 0 ? x : 0.0
        end

        @test occursin("The `enable` option is deprecated", msg)
        @test occursin("The `warnonly` option is deprecated", msg)
        msg2 = @capture_err f(1)

        @test occursin("DispatchDoctor.TypeInstabilityWarning", msg2)

        @stable enable = false function f(x)
            return x > 0 ? x : 0.0
        end
        @test f(0) == 0.0
    end
end
@testitem "Miscellaneous" begin
    using DispatchDoctor: DispatchDoctor as DD
    using DispatchDoctor: _Utils as DDU

    @test DD.extract_symbol(:([1, 2])) == DD.Unknown(string(:([1, 2])))

    @test DD.is_precompiling() == false

    @test DD.specializing_typeof(Val(1)) <: Val{1}

    @test DDU.is_function_name_compatible(1.0) == false
    @test DDU.is_symbol_like(1.0) == false

    if Base.isdefined(Core, :TypeofBottom)
        @test DD.type_instability(Core.TypeofBottom) == false
        @test DD.type_instability_limit_unions(Core.TypeofBottom, Val(1)) == false
    end
end
@testitem "Code quality (Aqua.jl)" begin
    using DispatchDoctor
    using Aqua

    Aqua.test_all(DispatchDoctor)
end
@testitem "Code linting (JET.jl)" begin
    using DispatchDoctor
    using JET

    if VERSION >= v"1.10"
        JET.test_package(DispatchDoctor; target_defined_modules=true)
    end
end
@testitem "llvm ir" begin
    using DispatchDoctor
    using PerformanceTestTools: @include

    DispatchDoctor.JULIA_OK && @include("llvm_ir_tests.jl")
    # Important to run the LLVM IR tests in a new
    # julia process with things like --code-coverage disabled.
    # See https://discourse.julialang.org/t/improving-speed-of-runtime-dispatch-detector/114697/14?u=milescranmer
end
@testitem "nospecialize tests" begin
    using DispatchDoctor

    @stable begin
        # Will ignore everything that has a @nospecialize macro:
        function test_nospecialize(@nospecialize(x))
            return x > 0 ? x : 0.0
        end
        function test_nospecialize_with_type(@nospecialize(x::Integer))
            return x > 0 ? x : 0.0
        end
        function test_nospecialize_with_default(@nospecialize(x)=1)
            return x > 0 ? x : 0.0
        end
        # Including keywords:
        function test_nospecialize_kwarg(x; @nospecialize(y))
            return x > 0 ? y : 0.0
        end
        function test_nospecialize_kwarg_typed(x; @nospecialize(y::Integer))
            return x > 0 ? y : 0.0
        end
        function test_nospecialize_kwarg_default(x; @nospecialize(y = 1))
            return x > 0 ? y : 0.0
        end
        # This will not stop other functions from being stabilized:
        f() = Val(rand())
    end
    @test test_nospecialize(1) == 1
    @test test_nospecialize_with_type(1) == 1
    @test test_nospecialize_with_default() == 1
    @test test_nospecialize_kwarg(1; y=2) == 2
    @test test_nospecialize_kwarg_typed(1; y=2) == 2
    @test test_nospecialize_kwarg_default(1) == 1
    @test_throws TypeInstabilityError f()
end
@testitem "issue with Vararg union limit" begin
    using DispatchDoctor
    using DispatchDoctor: @stable

    @stable default_union_limit = 2 function tuple_from_vector(v::Vector{Int})
        # Converting a vector with unknown length to a tuple yields
        # `Tuple{Vararg{Int64}}`, which internally stores `Core.TypeofVararg`.
        # This hits the missing method in `type_instability_limit_unions`.
        return Tuple(v)
    end

    DispatchDoctor.JULIA_OK &&
        @test_throws TypeInstabilityError tuple_from_vector([1, 2, 3])

    @stable function tuple_from_vector2(v::Vector{Int})
        return Tuple(v)
    end
    DispatchDoctor.JULIA_OK &&
        @test_throws TypeInstabilityError tuple_from_vector2([1, 2, 3])
end
@testitem "issue with specializing_typeof on unbound type parameters" begin
    using DispatchDoctor

    @stable function test_function(arg::Type{<:Type})
        return nothing
    end

    # This should trigger the error
    P = (Type{T} where {T}).body
    @test test_function(P) === nothing
end
@testitem "issue with closures causing instability" begin
    using DispatchDoctor

    @stable function f(x)
        @stable g() = x
        return g
    end

    @test_nowarn f(1.0)()
    @test f(1.0)() == 1.0
end
@testitem "issue with nested allow_unstable" begin
    using DispatchDoctor

    @stable f() = Val(rand())

    # Issue was that the `allow_unstable` would set the
    # `INSTABILITY_CHECK_ENABLED` to `false` and then the
    # `f` would throw an error, _even though_ we are still
    # within another `allow_unstable` block.
    @test_nowarn allow_unstable(() -> (allow_unstable(f); f()))
    @test_throws TypeInstabilityError f()
end

@run_package_tests

# Reference

## Macros

```@docs
@stable
@unstable
```

## Utilities

If you wish to turn off `@stable` for a single function call,
you can use `allow_unstable`:

```@docs
allow_unstable
```

`@stable` will normally interact with macros by propagating
them to the function definition as well as the function simulator.
If you would like to change this behavior, or declare a macro as being
incompatible with `@stable`, you can use `register_macro!`:

```@docs
register_macro!
```

## Internals

```@docs
DispatchDoctor.type_instability
```
